/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BatchConnectorMigrationTask', 'model/BatchConnectorMigrationTaskList', 'model/ConnectorMigrationTask', 'model/ConnectorMigrationTasks', 'model/SearchFilter'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BatchConnectorMigrationTask'), require('../model/BatchConnectorMigrationTaskList'), require('../model/ConnectorMigrationTask'), require('../model/ConnectorMigrationTasks'), require('../model/SearchFilter'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.AWSConnectorMigrationTasksApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.BatchConnectorMigrationTask, root.Deepsecurity.BatchConnectorMigrationTaskList, root.Deepsecurity.ConnectorMigrationTask, root.Deepsecurity.ConnectorMigrationTasks, root.Deepsecurity.SearchFilter);
  }
}(this, function(ApiClient, BatchConnectorMigrationTask, BatchConnectorMigrationTaskList, ConnectorMigrationTask, ConnectorMigrationTasks, SearchFilter) {
  'use strict';

  /**
   * AWSConnectorMigrationTasks service.
   * @module api/AWSConnectorMigrationTasksApi
   * @version 20.0.904
   */

  /**
   * Constructs a new AWSConnectorMigrationTasksApi. 
   * @alias module:api/AWSConnectorMigrationTasksApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create a Connector Migration Task
     * Create a new AWS Connector Migration Task.
     * @param {module:model/ConnectorMigrationTask} connectorMigrationTask The task to migrate the connector.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ConnectorMigrationTask} and HTTP response
     */
    this.createConnectorMigrationTaskWithHttpInfo = function(connectorMigrationTask, apiVersion) {
      var postBody = connectorMigrationTask;

      // verify the required parameter 'connectorMigrationTask' is set
      if (connectorMigrationTask === undefined || connectorMigrationTask === null) {
        throw new Error("Missing the required parameter 'connectorMigrationTask' when calling createConnectorMigrationTask");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createConnectorMigrationTask");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ConnectorMigrationTask;

      return this.apiClient.callApi(
        '/connectormigrationtasks/aws', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a Connector Migration Task
     * Create a new AWS Connector Migration Task.
     * @param {module:model/ConnectorMigrationTask} connectorMigrationTask The task to migrate the connector.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ConnectorMigrationTask}
     */
    this.createConnectorMigrationTask = function(connectorMigrationTask, apiVersion) {
      return this.createConnectorMigrationTaskWithHttpInfo(connectorMigrationTask, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Create Connector Migration Tasks
     * Create new AWS Connector Migration Tasks.
     * @param {module:model/BatchConnectorMigrationTask} connectorIDs The task to migrate the connector.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/BatchConnectorMigrationTaskList} and HTTP response
     */
    this.createConnectorMigrationTasksWithHttpInfo = function(connectorIDs, apiVersion) {
      var postBody = connectorIDs;

      // verify the required parameter 'connectorIDs' is set
      if (connectorIDs === undefined || connectorIDs === null) {
        throw new Error("Missing the required parameter 'connectorIDs' when calling createConnectorMigrationTasks");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createConnectorMigrationTasks");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = BatchConnectorMigrationTaskList;

      return this.apiClient.callApi(
        '/batchconnectormigrationtasks/aws', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create Connector Migration Tasks
     * Create new AWS Connector Migration Tasks.
     * @param {module:model/BatchConnectorMigrationTask} connectorIDs The task to migrate the connector.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/BatchConnectorMigrationTaskList}
     */
    this.createConnectorMigrationTasks = function(connectorIDs, apiVersion) {
      return this.createConnectorMigrationTasksWithHttpInfo(connectorIDs, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe a Connector Migration Task
     * Describe an AWS connector migration task.
     * @param {Number} connectorMigrationTaskID The ID number of the connector migration task to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ConnectorMigrationTask} and HTTP response
     */
    this.describeConnectorMigrationTaskWithHttpInfo = function(connectorMigrationTaskID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'connectorMigrationTaskID' is set
      if (connectorMigrationTaskID === undefined || connectorMigrationTaskID === null) {
        throw new Error("Missing the required parameter 'connectorMigrationTaskID' when calling describeConnectorMigrationTask");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeConnectorMigrationTask");
      }


      var pathParams = {
        'connectorMigrationTaskID': connectorMigrationTaskID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ConnectorMigrationTask;

      return this.apiClient.callApi(
        '/connectormigrationtasks/aws/{connectorMigrationTaskID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe a Connector Migration Task
     * Describe an AWS connector migration task.
     * @param {Number} connectorMigrationTaskID The ID number of the connector migration task to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ConnectorMigrationTask}
     */
    this.describeConnectorMigrationTask = function(connectorMigrationTaskID, apiVersion) {
      return this.describeConnectorMigrationTaskWithHttpInfo(connectorMigrationTaskID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List Connector Migration Tasks
     * Describe AWS connector migration tasks.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ConnectorMigrationTasks} and HTTP response
     */
    this.listConnectorMigrationTasksWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listConnectorMigrationTasks");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ConnectorMigrationTasks;

      return this.apiClient.callApi(
        '/connectormigrationtasks/aws', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List Connector Migration Tasks
     * Describe AWS connector migration tasks.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ConnectorMigrationTasks}
     */
    this.listConnectorMigrationTasks = function(apiVersion) {
      return this.listConnectorMigrationTasksWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Search Connector Migration Tasks
     * Search for AWS connector migration task using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ConnectorMigrationTasks} and HTTP response
     */
    this.searchConnectorMigrationTasksWithHttpInfo = function(apiVersion, opts) {
      opts = opts || {};
      var postBody = opts['searchFilter'];

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling searchConnectorMigrationTasks");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ConnectorMigrationTasks;

      return this.apiClient.callApi(
        '/connectormigrationtasks/aws/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Search Connector Migration Tasks
     * Search for AWS connector migration task using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ConnectorMigrationTasks}
     */
    this.searchConnectorMigrationTasks = function(apiVersion, opts) {
      return this.searchConnectorMigrationTasksWithHttpInfo(apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
