/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AgentDeploymentScript'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AgentDeploymentScript'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.AgentDeploymentScriptsApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.AgentDeploymentScript);
  }
}(this, function(ApiClient, AgentDeploymentScript) {
  'use strict';

  /**
   * AgentDeploymentScripts service.
   * @module api/AgentDeploymentScriptsApi
   * @version 20.0.904
   */

  /**
   * Constructs a new AgentDeploymentScriptsApi. 
   * @alias module:api/AgentDeploymentScriptsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Generate Agent Deployment Scripts
     * Generate agent deployment scripts by platform.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/AgentDeploymentScript} opts.agentDeploymentScript The platform type and activation details for the agent.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/AgentDeploymentScript} and HTTP response
     */
    this.generateAgentDeploymentScriptWithHttpInfo = function(apiVersion, opts) {
      opts = opts || {};
      var postBody = opts['agentDeploymentScript'];

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling generateAgentDeploymentScript");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = AgentDeploymentScript;

      return this.apiClient.callApi(
        '/agentdeploymentscripts', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Generate Agent Deployment Scripts
     * Generate agent deployment scripts by platform.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/AgentDeploymentScript} opts.agentDeploymentScript The platform type and activation details for the agent.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/AgentDeploymentScript}
     */
    this.generateAgentDeploymentScript = function(apiVersion, opts) {
      return this.generateAgentDeploymentScriptWithHttpInfo(apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
