/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AgentVersionControl', 'model/AgentVersionControls', 'model/SearchFilter'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AgentVersionControl'), require('../model/AgentVersionControls'), require('../model/SearchFilter'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.AgentVersionControlsApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.AgentVersionControl, root.Deepsecurity.AgentVersionControls, root.Deepsecurity.SearchFilter);
  }
}(this, function(ApiClient, AgentVersionControl, AgentVersionControls, SearchFilter) {
  'use strict';

  /**
   * AgentVersionControls service.
   * @module api/AgentVersionControlsApi
   * @version 20.0.904
   */

  /**
   * Constructs a new AgentVersionControlsApi. 
   * @alias module:api/AgentVersionControlsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Describe an agent version control
     * Describe an Agent Version Control by ID.
     * @param {Number} agentVersionControlProfileID The ID number of the agent version control profile.
     * @param {Number} agentVersionControlID The ID number of the agent version control to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/AgentVersionControl} and HTTP response
     */
    this.describeAgentVersionControlWithHttpInfo = function(agentVersionControlProfileID, agentVersionControlID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'agentVersionControlProfileID' is set
      if (agentVersionControlProfileID === undefined || agentVersionControlProfileID === null) {
        throw new Error("Missing the required parameter 'agentVersionControlProfileID' when calling describeAgentVersionControl");
      }

      // verify the required parameter 'agentVersionControlID' is set
      if (agentVersionControlID === undefined || agentVersionControlID === null) {
        throw new Error("Missing the required parameter 'agentVersionControlID' when calling describeAgentVersionControl");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeAgentVersionControl");
      }


      var pathParams = {
        'agentVersionControlProfileID': agentVersionControlProfileID,
        'agentVersionControlID': agentVersionControlID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = AgentVersionControl;

      return this.apiClient.callApi(
        '/agentversioncontrolprofiles/{agentVersionControlProfileID}/agentversioncontrols/{agentVersionControlID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe an agent version control
     * Describe an Agent Version Control by ID.
     * @param {Number} agentVersionControlProfileID The ID number of the agent version control profile.
     * @param {Number} agentVersionControlID The ID number of the agent version control to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/AgentVersionControl}
     */
    this.describeAgentVersionControl = function(agentVersionControlProfileID, agentVersionControlID, apiVersion) {
      return this.describeAgentVersionControlWithHttpInfo(agentVersionControlProfileID, agentVersionControlID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List agent version controls
     * Lists all agent version controls.
     * @param {Number} agentVersionControlProfileID The ID number of the agent version control profile.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/AgentVersionControls} and HTTP response
     */
    this.listAgentVersionControlsWithHttpInfo = function(agentVersionControlProfileID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'agentVersionControlProfileID' is set
      if (agentVersionControlProfileID === undefined || agentVersionControlProfileID === null) {
        throw new Error("Missing the required parameter 'agentVersionControlProfileID' when calling listAgentVersionControls");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listAgentVersionControls");
      }


      var pathParams = {
        'agentVersionControlProfileID': agentVersionControlProfileID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = AgentVersionControls;

      return this.apiClient.callApi(
        '/agentversioncontrolprofiles/{agentVersionControlProfileID}/agentversioncontrols', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List agent version controls
     * Lists all agent version controls.
     * @param {Number} agentVersionControlProfileID The ID number of the agent version control profile.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/AgentVersionControls}
     */
    this.listAgentVersionControls = function(agentVersionControlProfileID, apiVersion) {
      return this.listAgentVersionControlsWithHttpInfo(agentVersionControlProfileID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Modify agent version controls
     * Modify the agent version controls. Any unset elements will be left unchanged.
     * @param {Number} agentVersionControlProfileID The ID number of the agent version control profile.
     * @param {module:model/AgentVersionControls} agentVersionControls The agent version controls to modify.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/AgentVersionControls} and HTTP response
     */
    this.modifyAgentVersionControlsWithHttpInfo = function(agentVersionControlProfileID, agentVersionControls, apiVersion) {
      var postBody = agentVersionControls;

      // verify the required parameter 'agentVersionControlProfileID' is set
      if (agentVersionControlProfileID === undefined || agentVersionControlProfileID === null) {
        throw new Error("Missing the required parameter 'agentVersionControlProfileID' when calling modifyAgentVersionControls");
      }

      // verify the required parameter 'agentVersionControls' is set
      if (agentVersionControls === undefined || agentVersionControls === null) {
        throw new Error("Missing the required parameter 'agentVersionControls' when calling modifyAgentVersionControls");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling modifyAgentVersionControls");
      }


      var pathParams = {
        'agentVersionControlProfileID': agentVersionControlProfileID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = AgentVersionControls;

      return this.apiClient.callApi(
        '/agentversioncontrolprofiles/{agentVersionControlProfileID}/agentversioncontrols', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Modify agent version controls
     * Modify the agent version controls. Any unset elements will be left unchanged.
     * @param {Number} agentVersionControlProfileID The ID number of the agent version control profile.
     * @param {module:model/AgentVersionControls} agentVersionControls The agent version controls to modify.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/AgentVersionControls}
     */
    this.modifyAgentVersionControls = function(agentVersionControlProfileID, agentVersionControls, apiVersion) {
      return this.modifyAgentVersionControlsWithHttpInfo(agentVersionControlProfileID, agentVersionControls, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Search agent version controls
     * Search for agent version controls using optional filters.
     * @param {Number} agentVersionControlProfileID The ID number of the agent version control profile.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/AgentVersionControls} and HTTP response
     */
    this.searchAgentVersionControlsWithHttpInfo = function(agentVersionControlProfileID, apiVersion, opts) {
      opts = opts || {};
      var postBody = opts['searchFilter'];

      // verify the required parameter 'agentVersionControlProfileID' is set
      if (agentVersionControlProfileID === undefined || agentVersionControlProfileID === null) {
        throw new Error("Missing the required parameter 'agentVersionControlProfileID' when calling searchAgentVersionControls");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling searchAgentVersionControls");
      }


      var pathParams = {
        'agentVersionControlProfileID': agentVersionControlProfileID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = AgentVersionControls;

      return this.apiClient.callApi(
        '/agentversioncontrolprofiles/{agentVersionControlProfileID}/agentversioncontrols/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Search agent version controls
     * Search for agent version controls using optional filters.
     * @param {Number} agentVersionControlProfileID The ID number of the agent version control profile.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/AgentVersionControls}
     */
    this.searchAgentVersionControls = function(agentVersionControlProfileID, apiVersion, opts) {
      return this.searchAgentVersionControlsWithHttpInfo(agentVersionControlProfileID, apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
