/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CommonObjectMigrationTask', 'model/CommonObjectMigrationTasks', 'model/SearchFilter'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/CommonObjectMigrationTask'), require('../model/CommonObjectMigrationTasks'), require('../model/SearchFilter'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.CommonObjectMigrationTasksApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.CommonObjectMigrationTask, root.Deepsecurity.CommonObjectMigrationTasks, root.Deepsecurity.SearchFilter);
  }
}(this, function(ApiClient, CommonObjectMigrationTask, CommonObjectMigrationTasks, SearchFilter) {
  'use strict';

  /**
   * CommonObjectMigrationTasks service.
   * @module api/CommonObjectMigrationTasksApi
   * @version 20.0.904
   */

  /**
   * Constructs a new CommonObjectMigrationTasksApi. 
   * @alias module:api/CommonObjectMigrationTasksApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create a Common Object Migration Task
     * Create a task to migrate common objects.
     * @param {module:model/CommonObjectMigrationTask} commonObjectMigrationTask The task to migrate the common objects.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/CommonObjectMigrationTask} and HTTP response
     */
    this.createCommonObjectMigrationTaskWithHttpInfo = function(commonObjectMigrationTask, apiVersion) {
      var postBody = commonObjectMigrationTask;

      // verify the required parameter 'commonObjectMigrationTask' is set
      if (commonObjectMigrationTask === undefined || commonObjectMigrationTask === null) {
        throw new Error("Missing the required parameter 'commonObjectMigrationTask' when calling createCommonObjectMigrationTask");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createCommonObjectMigrationTask");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = CommonObjectMigrationTask;

      return this.apiClient.callApi(
        '/commonobjectmigrationtasks', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a Common Object Migration Task
     * Create a task to migrate common objects.
     * @param {module:model/CommonObjectMigrationTask} commonObjectMigrationTask The task to migrate the common objects.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/CommonObjectMigrationTask}
     */
    this.createCommonObjectMigrationTask = function(commonObjectMigrationTask, apiVersion) {
      return this.createCommonObjectMigrationTaskWithHttpInfo(commonObjectMigrationTask, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe a Common Object Migration Task
     * Describe a common object migration task.
     * @param {Number} commonObjectMigrationTaskID The ID number of the common object migration task to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/CommonObjectMigrationTask} and HTTP response
     */
    this.describeCommonObjectMigrationTaskWithHttpInfo = function(commonObjectMigrationTaskID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'commonObjectMigrationTaskID' is set
      if (commonObjectMigrationTaskID === undefined || commonObjectMigrationTaskID === null) {
        throw new Error("Missing the required parameter 'commonObjectMigrationTaskID' when calling describeCommonObjectMigrationTask");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeCommonObjectMigrationTask");
      }


      var pathParams = {
        'commonObjectMigrationTaskID': commonObjectMigrationTaskID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = CommonObjectMigrationTask;

      return this.apiClient.callApi(
        '/commonobjectmigrationtasks/{commonObjectMigrationTaskID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe a Common Object Migration Task
     * Describe a common object migration task.
     * @param {Number} commonObjectMigrationTaskID The ID number of the common object migration task to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/CommonObjectMigrationTask}
     */
    this.describeCommonObjectMigrationTask = function(commonObjectMigrationTaskID, apiVersion) {
      return this.describeCommonObjectMigrationTaskWithHttpInfo(commonObjectMigrationTaskID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List Common Object Migration Tasks
     * List all common object migration tasks.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/CommonObjectMigrationTasks} and HTTP response
     */
    this.listCommonObjectMigrationTasksWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listCommonObjectMigrationTasks");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = CommonObjectMigrationTasks;

      return this.apiClient.callApi(
        '/commonobjectmigrationtasks', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List Common Object Migration Tasks
     * List all common object migration tasks.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/CommonObjectMigrationTasks}
     */
    this.listCommonObjectMigrationTasks = function(apiVersion) {
      return this.listCommonObjectMigrationTasksWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Search Common Object Migration Tasks
     * Search for common obeject migration tasks using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/CommonObjectMigrationTasks} and HTTP response
     */
    this.searchCommonObjectMigrationTasksWithHttpInfo = function(apiVersion, opts) {
      opts = opts || {};
      var postBody = opts['searchFilter'];

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling searchCommonObjectMigrationTasks");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = CommonObjectMigrationTasks;

      return this.apiClient.callApi(
        '/commonobjectmigrationtasks/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Search Common Object Migration Tasks
     * Search for common obeject migration tasks using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/CommonObjectMigrationTasks}
     */
    this.searchCommonObjectMigrationTasks = function(apiVersion, opts) {
      return this.searchCommonObjectMigrationTasksWithHttpInfo(apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
