/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BatchComputerMoveTask', 'model/BatchComputerMoveTaskList', 'model/ComputerMoveTask', 'model/ComputerMoveTasks', 'model/SearchFilter'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BatchComputerMoveTask'), require('../model/BatchComputerMoveTaskList'), require('../model/ComputerMoveTask'), require('../model/ComputerMoveTasks'), require('../model/SearchFilter'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ComputerMoveTasksApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.BatchComputerMoveTask, root.Deepsecurity.BatchComputerMoveTaskList, root.Deepsecurity.ComputerMoveTask, root.Deepsecurity.ComputerMoveTasks, root.Deepsecurity.SearchFilter);
  }
}(this, function(ApiClient, BatchComputerMoveTask, BatchComputerMoveTaskList, ComputerMoveTask, ComputerMoveTasks, SearchFilter) {
  'use strict';

  /**
   * ComputerMoveTasks service.
   * @module api/ComputerMoveTasksApi
   * @version 20.0.904
   */

  /**
   * Constructs a new ComputerMoveTasksApi. 
   * @alias module:api/ComputerMoveTasksApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create a Batch Computer Move Task
     * Create a new batch computer move task.
     * @param {module:model/BatchComputerMoveTask} batchComputerMoveTask Tasks to move the computers.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/BatchComputerMoveTaskList} and HTTP response
     */
    this.createBatchComputerMoveTaskWithHttpInfo = function(batchComputerMoveTask, apiVersion) {
      var postBody = batchComputerMoveTask;

      // verify the required parameter 'batchComputerMoveTask' is set
      if (batchComputerMoveTask === undefined || batchComputerMoveTask === null) {
        throw new Error("Missing the required parameter 'batchComputerMoveTask' when calling createBatchComputerMoveTask");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createBatchComputerMoveTask");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = BatchComputerMoveTaskList;

      return this.apiClient.callApi(
        '/batchcomputermovetasks', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a Batch Computer Move Task
     * Create a new batch computer move task.
     * @param {module:model/BatchComputerMoveTask} batchComputerMoveTask Tasks to move the computers.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/BatchComputerMoveTaskList}
     */
    this.createBatchComputerMoveTask = function(batchComputerMoveTask, apiVersion) {
      return this.createBatchComputerMoveTaskWithHttpInfo(batchComputerMoveTask, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Create a Computer Move Task
     * Create a new computer move task.
     * @param {module:model/ComputerMoveTask} computerMoveTask The task to move the computers.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ComputerMoveTask} and HTTP response
     */
    this.createComputerMoveTaskWithHttpInfo = function(computerMoveTask, apiVersion) {
      var postBody = computerMoveTask;

      // verify the required parameter 'computerMoveTask' is set
      if (computerMoveTask === undefined || computerMoveTask === null) {
        throw new Error("Missing the required parameter 'computerMoveTask' when calling createComputerMoveTask");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createComputerMoveTask");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ComputerMoveTask;

      return this.apiClient.callApi(
        '/computermovetasks', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a Computer Move Task
     * Create a new computer move task.
     * @param {module:model/ComputerMoveTask} computerMoveTask The task to move the computers.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ComputerMoveTask}
     */
    this.createComputerMoveTask = function(computerMoveTask, apiVersion) {
      return this.createComputerMoveTaskWithHttpInfo(computerMoveTask, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe a Computer Move Task
     * Describe a computer move task.
     * @param {Number} computerMoveTaskID The ID number of the computer move task to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ComputerMoveTask} and HTTP response
     */
    this.describeComputerMoveTaskWithHttpInfo = function(computerMoveTaskID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'computerMoveTaskID' is set
      if (computerMoveTaskID === undefined || computerMoveTaskID === null) {
        throw new Error("Missing the required parameter 'computerMoveTaskID' when calling describeComputerMoveTask");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeComputerMoveTask");
      }


      var pathParams = {
        'computerMoveTaskID': computerMoveTaskID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ComputerMoveTask;

      return this.apiClient.callApi(
        '/computermovetasks/{computerMoveTaskID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe a Computer Move Task
     * Describe a computer move task.
     * @param {Number} computerMoveTaskID The ID number of the computer move task to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ComputerMoveTask}
     */
    this.describeComputerMoveTask = function(computerMoveTaskID, apiVersion) {
      return this.describeComputerMoveTaskWithHttpInfo(computerMoveTaskID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List Computer Move Tasks
     * List all computer move tasks.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ComputerMoveTasks} and HTTP response
     */
    this.listComputerMoveTasksWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listComputerMoveTasks");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ComputerMoveTasks;

      return this.apiClient.callApi(
        '/computermovetasks', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List Computer Move Tasks
     * List all computer move tasks.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ComputerMoveTasks}
     */
    this.listComputerMoveTasks = function(apiVersion) {
      return this.listComputerMoveTasksWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Search Computer Move Tasks
     * Search for computer move task using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ComputerMoveTasks} and HTTP response
     */
    this.searchComputerMoveTasksWithHttpInfo = function(apiVersion, opts) {
      opts = opts || {};
      var postBody = opts['searchFilter'];

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling searchComputerMoveTasks");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ComputerMoveTasks;

      return this.apiClient.callApi(
        '/computermovetasks/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Search Computer Move Tasks
     * Search for computer move task using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ComputerMoveTasks}
     */
    this.searchComputerMoveTasks = function(apiVersion, opts) {
      return this.searchComputerMoveTasksWithHttpInfo(apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
