/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/EndpointBasecampAgentDeploymentScript'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/EndpointBasecampAgentDeploymentScript'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.EndpointBasecampAgentDeploymentScriptsApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.EndpointBasecampAgentDeploymentScript);
  }
}(this, function(ApiClient, EndpointBasecampAgentDeploymentScript) {
  'use strict';

  /**
   * EndpointBasecampAgentDeploymentScripts service.
   * @module api/EndpointBasecampAgentDeploymentScriptsApi
   * @version 20.0.904
   */

  /**
   * Constructs a new EndpointBasecampAgentDeploymentScriptsApi. 
   * @alias module:api/EndpointBasecampAgentDeploymentScriptsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Generate Endpoint Basecamp Agent Deployment Scripts
     * Generate Endpoint Basecamp Agent deployment scripts by platform.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/EndpointBasecampAgentDeploymentScript} opts.endpointBasecampAgentDeploymentScript The platform type for the Endpoint Basecamp Agent.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/EndpointBasecampAgentDeploymentScript} and HTTP response
     */
    this.generateEndpointBasecampAgentDeploymentScriptWithHttpInfo = function(apiVersion, opts) {
      opts = opts || {};
      var postBody = opts['endpointBasecampAgentDeploymentScript'];

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling generateEndpointBasecampAgentDeploymentScript");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = EndpointBasecampAgentDeploymentScript;

      return this.apiClient.callApi(
        '/endpointbasecampagentdeploymentscripts', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Generate Endpoint Basecamp Agent Deployment Scripts
     * Generate Endpoint Basecamp Agent deployment scripts by platform.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/EndpointBasecampAgentDeploymentScript} opts.endpointBasecampAgentDeploymentScript The platform type for the Endpoint Basecamp Agent.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/EndpointBasecampAgentDeploymentScript}
     */
    this.generateEndpointBasecampAgentDeploymentScript = function(apiVersion, opts) {
      return this.generateEndpointBasecampAgentDeploymentScriptWithHttpInfo(apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
