/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ExceptionRules'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/ExceptionRules'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.PolicyDeviceControlExceptionRulesApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.ExceptionRules);
  }
}(this, function(ApiClient, ExceptionRules) {
  'use strict';

  /**
   * PolicyDeviceControlExceptionRules service.
   * @module api/PolicyDeviceControlExceptionRulesApi
   * @version 20.0.904
   */

  /**
   * Constructs a new PolicyDeviceControlExceptionRulesApi. 
   * @alias module:api/PolicyDeviceControlExceptionRulesApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Add Device Exception Rules
     * Assign device exception rules to a policy.
     * @param {Number} policyID The ID number of the policy.
     * @param {module:model/ExceptionRules} exceptionRules Exception Rules for the device.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Return only Exception Rules directly related to the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ExceptionRules} and HTTP response
     */
    this.addExceptionRulesOnPolicyWithHttpInfo = function(policyID, exceptionRules, apiVersion, opts) {
      opts = opts || {};
      var postBody = exceptionRules;

      // verify the required parameter 'policyID' is set
      if (policyID === undefined || policyID === null) {
        throw new Error("Missing the required parameter 'policyID' when calling addExceptionRulesOnPolicy");
      }

      // verify the required parameter 'exceptionRules' is set
      if (exceptionRules === undefined || exceptionRules === null) {
        throw new Error("Missing the required parameter 'exceptionRules' when calling addExceptionRulesOnPolicy");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling addExceptionRulesOnPolicy");
      }


      var pathParams = {
        'policyID': policyID
      };
      var queryParams = {
        'overrides': opts['overrides'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ExceptionRules;

      return this.apiClient.callApi(
        '/policies/{policyID}/devicecontrol/usbdeviceexceptionrules', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Add Device Exception Rules
     * Assign device exception rules to a policy.
     * @param {Number} policyID The ID number of the policy.
     * @param {module:model/ExceptionRules} exceptionRules Exception Rules for the device.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Return only Exception Rules directly related to the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ExceptionRules}
     */
    this.addExceptionRulesOnPolicy = function(policyID, exceptionRules, apiVersion, opts) {
      return this.addExceptionRulesOnPolicyWithHttpInfo(policyID, exceptionRules, apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List Device Exception Rules
     * Lists all device exception rules assigned to a policy.
     * @param {Number} policyID The ID number of the policy.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Return only Exception Rules directly related to the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ExceptionRules} and HTTP response
     */
    this.listExceptionRulesOnPolicyWithHttpInfo = function(policyID, apiVersion, opts) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'policyID' is set
      if (policyID === undefined || policyID === null) {
        throw new Error("Missing the required parameter 'policyID' when calling listExceptionRulesOnPolicy");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listExceptionRulesOnPolicy");
      }


      var pathParams = {
        'policyID': policyID
      };
      var queryParams = {
        'overrides': opts['overrides'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ExceptionRules;

      return this.apiClient.callApi(
        '/policies/{policyID}/devicecontrol/usbdeviceexceptionrules', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List Device Exception Rules
     * Lists all device exception rules assigned to a policy.
     * @param {Number} policyID The ID number of the policy.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Return only Exception Rules directly related to the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ExceptionRules}
     */
    this.listExceptionRulesOnPolicy = function(policyID, apiVersion, opts) {
      return this.listExceptionRulesOnPolicyWithHttpInfo(policyID, apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Remove a Device Exception Rule
     * Unassign a device exception rule from a policy.
     * @param {Number} policyID The ID number of the policy.
     * @param {Number} exceptionRuleID The ID number of the Exception Rule to delete.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Return only Exception Rules directly related to the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ExceptionRules} and HTTP response
     */
    this.removeExceptionRuleOnPolicyWithHttpInfo = function(policyID, exceptionRuleID, apiVersion, opts) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'policyID' is set
      if (policyID === undefined || policyID === null) {
        throw new Error("Missing the required parameter 'policyID' when calling removeExceptionRuleOnPolicy");
      }

      // verify the required parameter 'exceptionRuleID' is set
      if (exceptionRuleID === undefined || exceptionRuleID === null) {
        throw new Error("Missing the required parameter 'exceptionRuleID' when calling removeExceptionRuleOnPolicy");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling removeExceptionRuleOnPolicy");
      }


      var pathParams = {
        'policyID': policyID,
        'exceptionRuleID': exceptionRuleID
      };
      var queryParams = {
        'overrides': opts['overrides'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ExceptionRules;

      return this.apiClient.callApi(
        '/policies/{policyID}/devicecontrol/usbdeviceexceptionrules/{exceptionRuleID}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Remove a Device Exception Rule
     * Unassign a device exception rule from a policy.
     * @param {Number} policyID The ID number of the policy.
     * @param {Number} exceptionRuleID The ID number of the Exception Rule to delete.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Return only Exception Rules directly related to the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ExceptionRules}
     */
    this.removeExceptionRuleOnPolicy = function(policyID, exceptionRuleID, apiVersion, opts) {
      return this.removeExceptionRuleOnPolicyWithHttpInfo(policyID, exceptionRuleID, apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Set Device Exception Rules
     * Set device exception rules assigned to a policy.
     * @param {Number} policyID The ID number of the policy.
     * @param {module:model/ExceptionRules} exceptionRules Exception Rules for the device.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Return only Exception Rules directly related to the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ExceptionRules} and HTTP response
     */
    this.setExceptionRulesOnPolicyWithHttpInfo = function(policyID, exceptionRules, apiVersion, opts) {
      opts = opts || {};
      var postBody = exceptionRules;

      // verify the required parameter 'policyID' is set
      if (policyID === undefined || policyID === null) {
        throw new Error("Missing the required parameter 'policyID' when calling setExceptionRulesOnPolicy");
      }

      // verify the required parameter 'exceptionRules' is set
      if (exceptionRules === undefined || exceptionRules === null) {
        throw new Error("Missing the required parameter 'exceptionRules' when calling setExceptionRulesOnPolicy");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling setExceptionRulesOnPolicy");
      }


      var pathParams = {
        'policyID': policyID
      };
      var queryParams = {
        'overrides': opts['overrides'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ExceptionRules;

      return this.apiClient.callApi(
        '/policies/{policyID}/devicecontrol/usbdeviceexceptionrules', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Set Device Exception Rules
     * Set device exception rules assigned to a policy.
     * @param {Number} policyID The ID number of the policy.
     * @param {module:model/ExceptionRules} exceptionRules Exception Rules for the device.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Return only Exception Rules directly related to the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ExceptionRules}
     */
    this.setExceptionRulesOnPolicy = function(policyID, exceptionRules, apiVersion, opts) {
      return this.setExceptionRulesOnPolicyWithHttpInfo(policyID, exceptionRules, apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
