/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/PolicyMigrationTask', 'model/PolicyMigrationTasks', 'model/SearchFilter'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/PolicyMigrationTask'), require('../model/PolicyMigrationTasks'), require('../model/SearchFilter'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.PolicyMigrationTasksApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.PolicyMigrationTask, root.Deepsecurity.PolicyMigrationTasks, root.Deepsecurity.SearchFilter);
  }
}(this, function(ApiClient, PolicyMigrationTask, PolicyMigrationTasks, SearchFilter) {
  'use strict';

  /**
   * PolicyMigrationTasks service.
   * @module api/PolicyMigrationTasksApi
   * @version 20.0.904
   */

  /**
   * Constructs a new PolicyMigrationTasksApi. 
   * @alias module:api/PolicyMigrationTasksApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create a Policy Migration Task
     * Create a new policy migration task.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PolicyMigrationTask} and HTTP response
     */
    this.createPolicyMigrationTaskWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createPolicyMigrationTask");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = PolicyMigrationTask;

      return this.apiClient.callApi(
        '/policymigrationtasks', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a Policy Migration Task
     * Create a new policy migration task.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PolicyMigrationTask}
     */
    this.createPolicyMigrationTask = function(apiVersion) {
      return this.createPolicyMigrationTaskWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe a Policy Migration Task
     * Describe a policy migration task.
     * @param {Number} policyMigrationTaskID The ID number of the policy migration task to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PolicyMigrationTask} and HTTP response
     */
    this.describePolicyMigrationTaskWithHttpInfo = function(policyMigrationTaskID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'policyMigrationTaskID' is set
      if (policyMigrationTaskID === undefined || policyMigrationTaskID === null) {
        throw new Error("Missing the required parameter 'policyMigrationTaskID' when calling describePolicyMigrationTask");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describePolicyMigrationTask");
      }


      var pathParams = {
        'policyMigrationTaskID': policyMigrationTaskID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = PolicyMigrationTask;

      return this.apiClient.callApi(
        '/policymigrationtasks/{policyMigrationTaskID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe a Policy Migration Task
     * Describe a policy migration task.
     * @param {Number} policyMigrationTaskID The ID number of the policy migration task to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PolicyMigrationTask}
     */
    this.describePolicyMigrationTask = function(policyMigrationTaskID, apiVersion) {
      return this.describePolicyMigrationTaskWithHttpInfo(policyMigrationTaskID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List Policy Migration Tasks
     * List all policy migration tasks.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PolicyMigrationTasks} and HTTP response
     */
    this.listPolicyMigrationTasksWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listPolicyMigrationTasks");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = PolicyMigrationTasks;

      return this.apiClient.callApi(
        '/policymigrationtasks', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List Policy Migration Tasks
     * List all policy migration tasks.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PolicyMigrationTasks}
     */
    this.listPolicyMigrationTasks = function(apiVersion) {
      return this.listPolicyMigrationTasksWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Search Policy Migration Tasks
     * Search for policy migration tasks using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PolicyMigrationTasks} and HTTP response
     */
    this.searchPolicyMigrationTasksWithHttpInfo = function(apiVersion, opts) {
      opts = opts || {};
      var postBody = opts['searchFilter'];

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling searchPolicyMigrationTasks");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = PolicyMigrationTasks;

      return this.apiClient.callApi(
        '/policymigrationtasks/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Search Policy Migration Tasks
     * Search for policy migration tasks using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PolicyMigrationTasks}
     */
    this.searchPolicyMigrationTasks = function(apiVersion, opts) {
      return this.searchPolicyMigrationTasksWithHttpInfo(apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
