/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SearchFilter', 'model/SmartFolder', 'model/SmartFolders'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/SearchFilter'), require('../model/SmartFolder'), require('../model/SmartFolders'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.SmartFoldersApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.SearchFilter, root.Deepsecurity.SmartFolder, root.Deepsecurity.SmartFolders);
  }
}(this, function(ApiClient, SearchFilter, SmartFolder, SmartFolders) {
  'use strict';

  /**
   * SmartFolders service.
   * @module api/SmartFoldersApi
   * @version 20.0.904
   */

  /**
   * Constructs a new SmartFoldersApi. 
   * @alias module:api/SmartFoldersApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create a Smart Folder
     * Create a smart folder.
     * @param {module:model/SmartFolder} smartFolder The settings of the smart folder to modify.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SmartFolder} and HTTP response
     */
    this.createSmartFolderWithHttpInfo = function(smartFolder, apiVersion) {
      var postBody = smartFolder;

      // verify the required parameter 'smartFolder' is set
      if (smartFolder === undefined || smartFolder === null) {
        throw new Error("Missing the required parameter 'smartFolder' when calling createSmartFolder");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createSmartFolder");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SmartFolder;

      return this.apiClient.callApi(
        '/smartfolders', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a Smart Folder
     * Create a smart folder.
     * @param {module:model/SmartFolder} smartFolder The settings of the smart folder to modify.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SmartFolder}
     */
    this.createSmartFolder = function(smartFolder, apiVersion) {
      return this.createSmartFolderWithHttpInfo(smartFolder, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete a Smart Folder
     * Delete a smart folder by ID.
     * @param {Number} smartFolderID The ID number of the smart folder to delete.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteSmartFolderWithHttpInfo = function(smartFolderID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'smartFolderID' is set
      if (smartFolderID === undefined || smartFolderID === null) {
        throw new Error("Missing the required parameter 'smartFolderID' when calling deleteSmartFolder");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling deleteSmartFolder");
      }


      var pathParams = {
        'smartFolderID': smartFolderID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/smartfolders/{smartFolderID}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete a Smart Folder
     * Delete a smart folder by ID.
     * @param {Number} smartFolderID The ID number of the smart folder to delete.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteSmartFolder = function(smartFolderID, apiVersion) {
      return this.deleteSmartFolderWithHttpInfo(smartFolderID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe a Smart Folder
     * Describe a smart folder by ID.
     * @param {Number} smartFolderID The ID number of the smart folder to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SmartFolder} and HTTP response
     */
    this.describeSmartFolderWithHttpInfo = function(smartFolderID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'smartFolderID' is set
      if (smartFolderID === undefined || smartFolderID === null) {
        throw new Error("Missing the required parameter 'smartFolderID' when calling describeSmartFolder");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeSmartFolder");
      }


      var pathParams = {
        'smartFolderID': smartFolderID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SmartFolder;

      return this.apiClient.callApi(
        '/smartfolders/{smartFolderID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe a Smart Folder
     * Describe a smart folder by ID.
     * @param {Number} smartFolderID The ID number of the smart folder to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SmartFolder}
     */
    this.describeSmartFolder = function(smartFolderID, apiVersion) {
      return this.describeSmartFolderWithHttpInfo(smartFolderID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List Smart Folders
     * Lists all smart folders.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SmartFolders} and HTTP response
     */
    this.listSmartFoldersWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listSmartFolders");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SmartFolders;

      return this.apiClient.callApi(
        '/smartfolders', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List Smart Folders
     * Lists all smart folders.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SmartFolders}
     */
    this.listSmartFolders = function(apiVersion) {
      return this.listSmartFoldersWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Modify a Smart Folder
     * Modify a smart folder by ID. Any unset elements will be left unchanged.
     * @param {Number} smartFolderID The ID number of the smart folder to modify.
     * @param {module:model/SmartFolder} smartFolder The settings of the smart folder to modify.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SmartFolder} and HTTP response
     */
    this.modifySmartFolderWithHttpInfo = function(smartFolderID, smartFolder, apiVersion) {
      var postBody = smartFolder;

      // verify the required parameter 'smartFolderID' is set
      if (smartFolderID === undefined || smartFolderID === null) {
        throw new Error("Missing the required parameter 'smartFolderID' when calling modifySmartFolder");
      }

      // verify the required parameter 'smartFolder' is set
      if (smartFolder === undefined || smartFolder === null) {
        throw new Error("Missing the required parameter 'smartFolder' when calling modifySmartFolder");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling modifySmartFolder");
      }


      var pathParams = {
        'smartFolderID': smartFolderID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SmartFolder;

      return this.apiClient.callApi(
        '/smartfolders/{smartFolderID}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Modify a Smart Folder
     * Modify a smart folder by ID. Any unset elements will be left unchanged.
     * @param {Number} smartFolderID The ID number of the smart folder to modify.
     * @param {module:model/SmartFolder} smartFolder The settings of the smart folder to modify.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SmartFolder}
     */
    this.modifySmartFolder = function(smartFolderID, smartFolder, apiVersion) {
      return this.modifySmartFolderWithHttpInfo(smartFolderID, smartFolder, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Search Smart Folders
     * Search for smart folders using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SmartFolders} and HTTP response
     */
    this.searchSmartFoldersWithHttpInfo = function(apiVersion, opts) {
      opts = opts || {};
      var postBody = opts['searchFilter'];

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling searchSmartFolders");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SmartFolders;

      return this.apiClient.callApi(
        '/smartfolders/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Search Smart Folders
     * Search for smart folders using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SmartFolders}
     */
    this.searchSmartFolders = function(apiVersion, opts) {
      return this.searchSmartFoldersWithHttpInfo(apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
