/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ApplicationControlTrustRule', 'model/TrustRuleUpdateRequest', 'model/TrustRules'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/ApplicationControlTrustRule'), require('../model/TrustRuleUpdateRequest'), require('../model/TrustRules'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.TrustRulesApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.ApplicationControlTrustRule, root.Deepsecurity.TrustRuleUpdateRequest, root.Deepsecurity.TrustRules);
  }
}(this, function(ApiClient, ApplicationControlTrustRule, TrustRuleUpdateRequest, TrustRules) {
  'use strict';

  /**
   * TrustRules service.
   * @module api/TrustRulesApi
   * @version 20.0.904
   */

  /**
   * Constructs a new TrustRulesApi. 
   * @alias module:api/TrustRulesApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create a Trust Rule
     * Create a new trust rule.
     * @param {module:model/ApplicationControlTrustRule} trustrule Settings of the new trust rule.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ApplicationControlTrustRule} and HTTP response
     */
    this.createTrustRuleWithHttpInfo = function(trustrule, apiVersion) {
      var postBody = trustrule;

      // verify the required parameter 'trustrule' is set
      if (trustrule === undefined || trustrule === null) {
        throw new Error("Missing the required parameter 'trustrule' when calling createTrustRule");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createTrustRule");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ApplicationControlTrustRule;

      return this.apiClient.callApi(
        '/applicationcontroltrustrules', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a Trust Rule
     * Create a new trust rule.
     * @param {module:model/ApplicationControlTrustRule} trustrule Settings of the new trust rule.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ApplicationControlTrustRule}
     */
    this.createTrustRule = function(trustrule, apiVersion) {
      return this.createTrustRuleWithHttpInfo(trustrule, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete a Trust Rule.
     * Delete a trust rule by ID.
     * @param {Number} acTrustRuleID The ID number of the trust rule to delete.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteTrustRuleWithHttpInfo = function(acTrustRuleID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'acTrustRuleID' is set
      if (acTrustRuleID === undefined || acTrustRuleID === null) {
        throw new Error("Missing the required parameter 'acTrustRuleID' when calling deleteTrustRule");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling deleteTrustRule");
      }


      var pathParams = {
        'acTrustRuleID': acTrustRuleID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/applicationcontroltrustrules/{acTrustRuleID}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete a Trust Rule.
     * Delete a trust rule by ID.
     * @param {Number} acTrustRuleID The ID number of the trust rule to delete.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteTrustRule = function(acTrustRuleID, apiVersion) {
      return this.deleteTrustRuleWithHttpInfo(acTrustRuleID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe a Trust Rule
     * Describe a trust rule by ID.
     * @param {Number} acTrustRuleID The ID number of the trust rule to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ApplicationControlTrustRule} and HTTP response
     */
    this.describeTrustRuleWithHttpInfo = function(acTrustRuleID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'acTrustRuleID' is set
      if (acTrustRuleID === undefined || acTrustRuleID === null) {
        throw new Error("Missing the required parameter 'acTrustRuleID' when calling describeTrustRule");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeTrustRule");
      }


      var pathParams = {
        'acTrustRuleID': acTrustRuleID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ApplicationControlTrustRule;

      return this.apiClient.callApi(
        '/applicationcontroltrustrules/{acTrustRuleID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe a Trust Rule
     * Describe a trust rule by ID.
     * @param {Number} acTrustRuleID The ID number of the trust rule to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ApplicationControlTrustRule}
     */
    this.describeTrustRule = function(acTrustRuleID, apiVersion) {
      return this.describeTrustRuleWithHttpInfo(acTrustRuleID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List all Trust Rules
     * List all trust rules.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TrustRules} and HTTP response
     */
    this.listTrustRulesWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listTrustRules");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TrustRules;

      return this.apiClient.callApi(
        '/applicationcontroltrustrules', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List all Trust Rules
     * List all trust rules.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TrustRules}
     */
    this.listTrustRules = function(apiVersion) {
      return this.listTrustRulesWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Modify a Trust Rule
     * Modify a trust rule by ID.
     * @param {Number} acTrustRuleID The ID of the trust rule to modify.
     * @param {module:model/TrustRuleUpdateRequest} requestTrustRulesetUpdate The attributes of the trust rule to modify.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ApplicationControlTrustRule} and HTTP response
     */
    this.modifyTrustRuleWithHttpInfo = function(acTrustRuleID, requestTrustRulesetUpdate, apiVersion) {
      var postBody = requestTrustRulesetUpdate;

      // verify the required parameter 'acTrustRuleID' is set
      if (acTrustRuleID === undefined || acTrustRuleID === null) {
        throw new Error("Missing the required parameter 'acTrustRuleID' when calling modifyTrustRule");
      }

      // verify the required parameter 'requestTrustRulesetUpdate' is set
      if (requestTrustRulesetUpdate === undefined || requestTrustRulesetUpdate === null) {
        throw new Error("Missing the required parameter 'requestTrustRulesetUpdate' when calling modifyTrustRule");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling modifyTrustRule");
      }


      var pathParams = {
        'acTrustRuleID': acTrustRuleID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ApplicationControlTrustRule;

      return this.apiClient.callApi(
        '/applicationcontroltrustrules/{acTrustRuleID}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Modify a Trust Rule
     * Modify a trust rule by ID.
     * @param {Number} acTrustRuleID The ID of the trust rule to modify.
     * @param {module:model/TrustRuleUpdateRequest} requestTrustRulesetUpdate The attributes of the trust rule to modify.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ApplicationControlTrustRule}
     */
    this.modifyTrustRule = function(acTrustRuleID, requestTrustRulesetUpdate, apiVersion) {
      return this.modifyTrustRuleWithHttpInfo(acTrustRuleID, requestTrustRulesetUpdate, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
