/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/RuleLongIDs', 'model/TrustRuleIDs', 'model/TrustRules', 'model/TrustRuleset', 'model/TrustRulesetAssignments', 'model/TrustRulesetUpdateRequest', 'model/TrustRulesets'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/RuleLongIDs'), require('../model/TrustRuleIDs'), require('../model/TrustRules'), require('../model/TrustRuleset'), require('../model/TrustRulesetAssignments'), require('../model/TrustRulesetUpdateRequest'), require('../model/TrustRulesets'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.TrustRulesetsApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.RuleLongIDs, root.Deepsecurity.TrustRuleIDs, root.Deepsecurity.TrustRules, root.Deepsecurity.TrustRuleset, root.Deepsecurity.TrustRulesetAssignments, root.Deepsecurity.TrustRulesetUpdateRequest, root.Deepsecurity.TrustRulesets);
  }
}(this, function(ApiClient, RuleLongIDs, TrustRuleIDs, TrustRules, TrustRuleset, TrustRulesetAssignments, TrustRulesetUpdateRequest, TrustRulesets) {
  'use strict';

  /**
   * TrustRulesets service.
   * @module api/TrustRulesetsApi
   * @version 20.0.904
   */

  /**
   * Constructs a new TrustRulesetsApi. 
   * @alias module:api/TrustRulesetsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Add Trust Rule IDs
     * Assign additional trust rule IDs to a trust ruleset.
     * @param {Number} acTrustRulesetID The ID number of the trust ruleset.
     * @param {module:model/RuleLongIDs} body The ID numbers of the trust rules to add.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TrustRuleIDs} and HTTP response
     */
    this.addTrustRulesWithHttpInfo = function(acTrustRulesetID, body, apiVersion) {
      var postBody = body;

      // verify the required parameter 'acTrustRulesetID' is set
      if (acTrustRulesetID === undefined || acTrustRulesetID === null) {
        throw new Error("Missing the required parameter 'acTrustRulesetID' when calling addTrustRules");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling addTrustRules");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling addTrustRules");
      }


      var pathParams = {
        'acTrustRulesetID': acTrustRulesetID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TrustRuleIDs;

      return this.apiClient.callApi(
        '/applicationcontroltrustrulesets/{acTrustRulesetID}/rules', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Add Trust Rule IDs
     * Assign additional trust rule IDs to a trust ruleset.
     * @param {Number} acTrustRulesetID The ID number of the trust ruleset.
     * @param {module:model/RuleLongIDs} body The ID numbers of the trust rules to add.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TrustRuleIDs}
     */
    this.addTrustRules = function(acTrustRulesetID, body, apiVersion) {
      return this.addTrustRulesWithHttpInfo(acTrustRulesetID, body, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Create a Trust Ruleset
     * Create a new trust ruleset.
     * @param {module:model/TrustRuleset} trustruleset The settings of the new trust ruleset.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TrustRuleset} and HTTP response
     */
    this.createTrustRulesetWithHttpInfo = function(trustruleset, apiVersion) {
      var postBody = trustruleset;

      // verify the required parameter 'trustruleset' is set
      if (trustruleset === undefined || trustruleset === null) {
        throw new Error("Missing the required parameter 'trustruleset' when calling createTrustRuleset");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createTrustRuleset");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TrustRuleset;

      return this.apiClient.callApi(
        '/applicationcontroltrustrulesets', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a Trust Ruleset
     * Create a new trust ruleset.
     * @param {module:model/TrustRuleset} trustruleset The settings of the new trust ruleset.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TrustRuleset}
     */
    this.createTrustRuleset = function(trustruleset, apiVersion) {
      return this.createTrustRulesetWithHttpInfo(trustruleset, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete a Trust Rule from a Trust Ruleset
     * Delete a single trust rule from a trust ruleset by the trust ruleset ID and the trust rule ID.
     * @param {Number} acTrustRulesetID The ID number of the trust ruleset.
     * @param {Number} acTrustRuleID The ID number of the trust rule to delete.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteTrustRuleFromTrustRulesetWithHttpInfo = function(acTrustRulesetID, acTrustRuleID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'acTrustRulesetID' is set
      if (acTrustRulesetID === undefined || acTrustRulesetID === null) {
        throw new Error("Missing the required parameter 'acTrustRulesetID' when calling deleteTrustRuleFromTrustRuleset");
      }

      // verify the required parameter 'acTrustRuleID' is set
      if (acTrustRuleID === undefined || acTrustRuleID === null) {
        throw new Error("Missing the required parameter 'acTrustRuleID' when calling deleteTrustRuleFromTrustRuleset");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling deleteTrustRuleFromTrustRuleset");
      }


      var pathParams = {
        'acTrustRulesetID': acTrustRulesetID,
        'acTrustRuleID': acTrustRuleID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/applicationcontroltrustrulesets/{acTrustRulesetID}/rules/{acTrustRuleID}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete a Trust Rule from a Trust Ruleset
     * Delete a single trust rule from a trust ruleset by the trust ruleset ID and the trust rule ID.
     * @param {Number} acTrustRulesetID The ID number of the trust ruleset.
     * @param {Number} acTrustRuleID The ID number of the trust rule to delete.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteTrustRuleFromTrustRuleset = function(acTrustRulesetID, acTrustRuleID, apiVersion) {
      return this.deleteTrustRuleFromTrustRulesetWithHttpInfo(acTrustRulesetID, acTrustRuleID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete a Trust Ruleset
     * Delete a trust ruleset by ID.
     * @param {Number} acTrustRulesetID The ID number of the trust ruleset to delete.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteTrustRulesetWithHttpInfo = function(acTrustRulesetID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'acTrustRulesetID' is set
      if (acTrustRulesetID === undefined || acTrustRulesetID === null) {
        throw new Error("Missing the required parameter 'acTrustRulesetID' when calling deleteTrustRuleset");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling deleteTrustRuleset");
      }


      var pathParams = {
        'acTrustRulesetID': acTrustRulesetID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/applicationcontroltrustrulesets/{acTrustRulesetID}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete a Trust Ruleset
     * Delete a trust ruleset by ID.
     * @param {Number} acTrustRulesetID The ID number of the trust ruleset to delete.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteTrustRuleset = function(acTrustRulesetID, apiVersion) {
      return this.deleteTrustRulesetWithHttpInfo(acTrustRulesetID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe a Trust Ruleset
     * Describe a trust ruleset by ID.
     * @param {Number} acTrustRulesetID The ID number of the trust ruleset to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TrustRuleset} and HTTP response
     */
    this.describeTrustRulesetWithHttpInfo = function(acTrustRulesetID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'acTrustRulesetID' is set
      if (acTrustRulesetID === undefined || acTrustRulesetID === null) {
        throw new Error("Missing the required parameter 'acTrustRulesetID' when calling describeTrustRuleset");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeTrustRuleset");
      }


      var pathParams = {
        'acTrustRulesetID': acTrustRulesetID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TrustRuleset;

      return this.apiClient.callApi(
        '/applicationcontroltrustrulesets/{acTrustRulesetID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe a Trust Ruleset
     * Describe a trust ruleset by ID.
     * @param {Number} acTrustRulesetID The ID number of the trust ruleset to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TrustRuleset}
     */
    this.describeTrustRuleset = function(acTrustRulesetID, apiVersion) {
      return this.describeTrustRulesetWithHttpInfo(acTrustRulesetID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List a Trust Ruleset Assignment
     * List a trust ruleset&#39;s computer and policy assignment by the trust ruleset ID.
     * @param {Number} acTrustRulesetID The ID of the trust ruleset
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TrustRulesetAssignments} and HTTP response
     */
    this.listTrustRulesetAssignmentsWithHttpInfo = function(acTrustRulesetID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'acTrustRulesetID' is set
      if (acTrustRulesetID === undefined || acTrustRulesetID === null) {
        throw new Error("Missing the required parameter 'acTrustRulesetID' when calling listTrustRulesetAssignments");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listTrustRulesetAssignments");
      }


      var pathParams = {
        'acTrustRulesetID': acTrustRulesetID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TrustRulesetAssignments;

      return this.apiClient.callApi(
        '/applicationcontroltrustrulesets/{acTrustRulesetID}/assignments', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List a Trust Ruleset Assignment
     * List a trust ruleset&#39;s computer and policy assignment by the trust ruleset ID.
     * @param {Number} acTrustRulesetID The ID of the trust ruleset
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TrustRulesetAssignments}
     */
    this.listTrustRulesetAssignments = function(acTrustRulesetID, apiVersion) {
      return this.listTrustRulesetAssignmentsWithHttpInfo(acTrustRulesetID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List Trust Rules in a Trust Ruleset
     * List all trust rules in a trust ruleset by trust ruleset ID.
     * @param {Number} acTrustRulesetID The ID of the trust ruleset.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TrustRules} and HTTP response
     */
    this.listTrustRulesetRulesWithHttpInfo = function(acTrustRulesetID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'acTrustRulesetID' is set
      if (acTrustRulesetID === undefined || acTrustRulesetID === null) {
        throw new Error("Missing the required parameter 'acTrustRulesetID' when calling listTrustRulesetRules");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listTrustRulesetRules");
      }


      var pathParams = {
        'acTrustRulesetID': acTrustRulesetID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TrustRules;

      return this.apiClient.callApi(
        '/applicationcontroltrustrulesets/{acTrustRulesetID}/rules', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List Trust Rules in a Trust Ruleset
     * List all trust rules in a trust ruleset by trust ruleset ID.
     * @param {Number} acTrustRulesetID The ID of the trust ruleset.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TrustRules}
     */
    this.listTrustRulesetRules = function(acTrustRulesetID, apiVersion) {
      return this.listTrustRulesetRulesWithHttpInfo(acTrustRulesetID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List Trust Rulesets
     * List all trust rulesets.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TrustRulesets} and HTTP response
     */
    this.listTrustRulesetsWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listTrustRulesets");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TrustRulesets;

      return this.apiClient.callApi(
        '/applicationcontroltrustrulesets', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List Trust Rulesets
     * List all trust rulesets.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TrustRulesets}
     */
    this.listTrustRulesets = function(apiVersion) {
      return this.listTrustRulesetsWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Modify a Trust Ruleset
     * Modify a trust ruleset&#39;s attributes by trust ruleset ID, including trust rule assignment.
     * @param {Number} acTrustRulesetID The ID number of the trust ruleset to modify.
     * @param {module:model/TrustRulesetUpdateRequest} body The attributes of the trust ruleset to modify.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TrustRuleset} and HTTP response
     */
    this.modifyTrustRulesetWithHttpInfo = function(acTrustRulesetID, body, apiVersion) {
      var postBody = body;

      // verify the required parameter 'acTrustRulesetID' is set
      if (acTrustRulesetID === undefined || acTrustRulesetID === null) {
        throw new Error("Missing the required parameter 'acTrustRulesetID' when calling modifyTrustRuleset");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling modifyTrustRuleset");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling modifyTrustRuleset");
      }


      var pathParams = {
        'acTrustRulesetID': acTrustRulesetID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TrustRuleset;

      return this.apiClient.callApi(
        '/applicationcontroltrustrulesets/{acTrustRulesetID}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Modify a Trust Ruleset
     * Modify a trust ruleset&#39;s attributes by trust ruleset ID, including trust rule assignment.
     * @param {Number} acTrustRulesetID The ID number of the trust ruleset to modify.
     * @param {module:model/TrustRulesetUpdateRequest} body The attributes of the trust ruleset to modify.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TrustRuleset}
     */
    this.modifyTrustRuleset = function(acTrustRulesetID, body, apiVersion) {
      return this.modifyTrustRulesetWithHttpInfo(acTrustRulesetID, body, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Set Trust Rule IDs in a Ruleset
     * Set only the specified trust rule IDs to be assigned to the trust ruleset.
     * @param {Number} acTrustRulesetID The ID number of the trust ruleset to modify.
     * @param {module:model/RuleLongIDs} body The ID numbers of the trust rules to set.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/TrustRuleIDs} and HTTP response
     */
    this.setTrustRulesWithHttpInfo = function(acTrustRulesetID, body, apiVersion) {
      var postBody = body;

      // verify the required parameter 'acTrustRulesetID' is set
      if (acTrustRulesetID === undefined || acTrustRulesetID === null) {
        throw new Error("Missing the required parameter 'acTrustRulesetID' when calling setTrustRules");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling setTrustRules");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling setTrustRules");
      }


      var pathParams = {
        'acTrustRulesetID': acTrustRulesetID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TrustRuleIDs;

      return this.apiClient.callApi(
        '/applicationcontroltrustrulesets/{acTrustRulesetID}/rules', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Set Trust Rule IDs in a Ruleset
     * Set only the specified trust rule IDs to be assigned to the trust ruleset.
     * @param {Number} acTrustRulesetID The ID number of the trust ruleset to modify.
     * @param {module:model/RuleLongIDs} body The ID numbers of the trust rules to set.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/TrustRuleIDs}
     */
    this.setTrustRules = function(acTrustRulesetID, body, apiVersion) {
      return this.setTrustRulesWithHttpInfo(acTrustRulesetID, body, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
