/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/VCenterConnectorAction'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/VCenterConnectorAction'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.VCenterConnectorActionsApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.VCenterConnectorAction);
  }
}(this, function(ApiClient, VCenterConnectorAction) {
  'use strict';

  /**
   * VCenterConnectorActions service.
   * @module api/VCenterConnectorActionsApi
   * @version 20.0.904
   */

  /**
   * Constructs a new VCenterConnectorActionsApi. 
   * @alias module:api/VCenterConnectorActionsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create a connector action
     * Create a connector action by connector ID.
     * @param {Number} virtualID ID number of the vCenter connector.
     * @param {module:model/VCenterConnectorAction} vCenterConnectorAction Property of the new vCenter connector action.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/VCenterConnectorAction} and HTTP response
     */
    this.createVCenterConnectorActionWithHttpInfo = function(virtualID, vCenterConnectorAction, apiVersion) {
      var postBody = vCenterConnectorAction;

      // verify the required parameter 'virtualID' is set
      if (virtualID === undefined || virtualID === null) {
        throw new Error("Missing the required parameter 'virtualID' when calling createVCenterConnectorAction");
      }

      // verify the required parameter 'vCenterConnectorAction' is set
      if (vCenterConnectorAction === undefined || vCenterConnectorAction === null) {
        throw new Error("Missing the required parameter 'vCenterConnectorAction' when calling createVCenterConnectorAction");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createVCenterConnectorAction");
      }


      var pathParams = {
        'virtualID': virtualID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = VCenterConnectorAction;

      return this.apiClient.callApi(
        '/vcenterconnectors/{virtualID}/actions', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a connector action
     * Create a connector action by connector ID.
     * @param {Number} virtualID ID number of the vCenter connector.
     * @param {module:model/VCenterConnectorAction} vCenterConnectorAction Property of the new vCenter connector action.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/VCenterConnectorAction}
     */
    this.createVCenterConnectorAction = function(virtualID, vCenterConnectorAction, apiVersion) {
      return this.createVCenterConnectorActionWithHttpInfo(virtualID, vCenterConnectorAction, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe a connector action
     * Describe a connector action by connector ID and action ID.
     * @param {Number} virtualID ID number of the vCenter connector.
     * @param {Number} actionID ID number of the vCenter connector action.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/VCenterConnectorAction} and HTTP response
     */
    this.describeVCenterConnectorActionWithHttpInfo = function(virtualID, actionID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'virtualID' is set
      if (virtualID === undefined || virtualID === null) {
        throw new Error("Missing the required parameter 'virtualID' when calling describeVCenterConnectorAction");
      }

      // verify the required parameter 'actionID' is set
      if (actionID === undefined || actionID === null) {
        throw new Error("Missing the required parameter 'actionID' when calling describeVCenterConnectorAction");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeVCenterConnectorAction");
      }


      var pathParams = {
        'virtualID': virtualID,
        'actionID': actionID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = VCenterConnectorAction;

      return this.apiClient.callApi(
        '/vcenterconnectors/{virtualID}/actions/{actionID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe a connector action
     * Describe a connector action by connector ID and action ID.
     * @param {Number} virtualID ID number of the vCenter connector.
     * @param {Number} actionID ID number of the vCenter connector action.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/VCenterConnectorAction}
     */
    this.describeVCenterConnectorAction = function(virtualID, actionID, apiVersion) {
      return this.describeVCenterConnectorActionWithHttpInfo(virtualID, actionID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
