/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/VCenterConnector', 'model/VCenterConnectors'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/VCenterConnector'), require('../model/VCenterConnectors'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.VCenterConnectorsApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.VCenterConnector, root.Deepsecurity.VCenterConnectors);
  }
}(this, function(ApiClient, VCenterConnector, VCenterConnectors) {
  'use strict';

  /**
   * VCenterConnectors service.
   * @module api/VCenterConnectorsApi
   * @version 20.0.904
   */

  /**
   * Constructs a new VCenterConnectorsApi. 
   * @alias module:api/VCenterConnectorsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create a vCenter connector
     * Create a new vCenter connector.
     * @param {module:model/VCenterConnector} vcenterConnector Settings for the new vCenter connector.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/VCenterConnector} and HTTP response
     */
    this.createVCenterConnectorWithHttpInfo = function(vcenterConnector, apiVersion) {
      var postBody = vcenterConnector;

      // verify the required parameter 'vcenterConnector' is set
      if (vcenterConnector === undefined || vcenterConnector === null) {
        throw new Error("Missing the required parameter 'vcenterConnector' when calling createVCenterConnector");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createVCenterConnector");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = VCenterConnector;

      return this.apiClient.callApi(
        '/vcenterconnectors', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a vCenter connector
     * Create a new vCenter connector.
     * @param {module:model/VCenterConnector} vcenterConnector Settings for the new vCenter connector.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/VCenterConnector}
     */
    this.createVCenterConnector = function(vcenterConnector, apiVersion) {
      return this.createVCenterConnectorWithHttpInfo(vcenterConnector, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete a vCenter connector
     * Delete a vCenter connector by ID.
     * @param {Number} virtualID ID number of the vCenter connector whose NSX Manager will be removed.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteVCenterConnectorWithHttpInfo = function(virtualID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'virtualID' is set
      if (virtualID === undefined || virtualID === null) {
        throw new Error("Missing the required parameter 'virtualID' when calling deleteVCenterConnector");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling deleteVCenterConnector");
      }


      var pathParams = {
        'virtualID': virtualID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/vcenterconnectors/{virtualID}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete a vCenter connector
     * Delete a vCenter connector by ID.
     * @param {Number} virtualID ID number of the vCenter connector whose NSX Manager will be removed.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteVCenterConnector = function(virtualID, apiVersion) {
      return this.deleteVCenterConnectorWithHttpInfo(virtualID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe a vCenter Connector
     * Describe a vCenter connector by ID.
     * @param {Number} virtualID ID number of the vCenter connector to describe.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/VCenterConnector} and HTTP response
     */
    this.describeVCenterConnectorWithHttpInfo = function(virtualID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'virtualID' is set
      if (virtualID === undefined || virtualID === null) {
        throw new Error("Missing the required parameter 'virtualID' when calling describeVCenterConnector");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeVCenterConnector");
      }


      var pathParams = {
        'virtualID': virtualID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = VCenterConnector;

      return this.apiClient.callApi(
        '/vcenterconnectors/{virtualID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe a vCenter Connector
     * Describe a vCenter connector by ID.
     * @param {Number} virtualID ID number of the vCenter connector to describe.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/VCenterConnector}
     */
    this.describeVCenterConnector = function(virtualID, apiVersion) {
      return this.describeVCenterConnectorWithHttpInfo(virtualID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List vCenter connectors
     * List all vCenter connectors.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/VCenterConnectors} and HTTP response
     */
    this.listVCenterConnectorsWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listVCenterConnectors");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = VCenterConnectors;

      return this.apiClient.callApi(
        '/vcenterconnectors', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List vCenter connectors
     * List all vCenter connectors.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/VCenterConnectors}
     */
    this.listVCenterConnectors = function(apiVersion) {
      return this.listVCenterConnectorsWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Modify a vCenter Connector
     * Modify a vCenter connector by ID.
     * @param {Number} virtualID ID number of the vCenter Connector to modify.
     * @param {String} apiVersion Version of the API being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/VCenterConnector} opts.vcenterConnector The settings of the vCenter connector to modify.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/VCenterConnector} and HTTP response
     */
    this.modifyVCenterConnectorWithHttpInfo = function(virtualID, apiVersion, opts) {
      opts = opts || {};
      var postBody = opts['vcenterConnector'];

      // verify the required parameter 'virtualID' is set
      if (virtualID === undefined || virtualID === null) {
        throw new Error("Missing the required parameter 'virtualID' when calling modifyVCenterConnector");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling modifyVCenterConnector");
      }


      var pathParams = {
        'virtualID': virtualID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = VCenterConnector;

      return this.apiClient.callApi(
        '/vcenterconnectors/{virtualID}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Modify a vCenter Connector
     * Modify a vCenter connector by ID.
     * @param {Number} virtualID ID number of the vCenter Connector to modify.
     * @param {String} apiVersion Version of the API being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/VCenterConnector} opts.vcenterConnector The settings of the vCenter connector to modify.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/VCenterConnector}
     */
    this.modifyVCenterConnector = function(virtualID, apiVersion, opts) {
      return this.modifyVCenterConnectorWithHttpInfo(virtualID, apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Remove NSX Manager
     * Remove the NSX Manager associated with the vCenter connector by ID.
     * @param {Number} virtualID ID number of the vCenter Connector to be deleted.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.removeNSXManagerWithHttpInfo = function(virtualID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'virtualID' is set
      if (virtualID === undefined || virtualID === null) {
        throw new Error("Missing the required parameter 'virtualID' when calling removeNSXManager");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling removeNSXManager");
      }


      var pathParams = {
        'virtualID': virtualID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/vcenterconnectors/{virtualID}/nsxmanagers', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Remove NSX Manager
     * Remove the NSX Manager associated with the vCenter connector by ID.
     * @param {Number} virtualID ID number of the vCenter Connector to be deleted.
     * @param {String} apiVersion Version of the API being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.removeNSXManager = function(virtualID, apiVersion) {
      return this.removeNSXManagerWithHttpInfo(virtualID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
