/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/MigrationInformation', 'model/WorkloadSecurityLink', 'model/WorkloadSecurityLinks'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/MigrationInformation'), require('../model/WorkloadSecurityLink'), require('../model/WorkloadSecurityLinks'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.WorkloadSecurityLinksApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.MigrationInformation, root.Deepsecurity.WorkloadSecurityLink, root.Deepsecurity.WorkloadSecurityLinks);
  }
}(this, function(ApiClient, MigrationInformation, WorkloadSecurityLink, WorkloadSecurityLinks) {
  'use strict';

  /**
   * WorkloadSecurityLinks service.
   * @module api/WorkloadSecurityLinksApi
   * @version 20.0.904
   */

  /**
   * Constructs a new WorkloadSecurityLinksApi. 
   * @alias module:api/WorkloadSecurityLinksApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create a Workload Security Link
     * Can create only one Workload Security Link, delete it to create another one.
     * @param {module:model/WorkloadSecurityLink} workloadSecurityLink The workload security link to create.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/WorkloadSecurityLink} and HTTP response
     */
    this.createWorkloadSecurityLinkWithHttpInfo = function(workloadSecurityLink, apiVersion) {
      var postBody = workloadSecurityLink;

      // verify the required parameter 'workloadSecurityLink' is set
      if (workloadSecurityLink === undefined || workloadSecurityLink === null) {
        throw new Error("Missing the required parameter 'workloadSecurityLink' when calling createWorkloadSecurityLink");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createWorkloadSecurityLink");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = WorkloadSecurityLink;

      return this.apiClient.callApi(
        '/workloadsecuritylinks', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a Workload Security Link
     * Can create only one Workload Security Link, delete it to create another one.
     * @param {module:model/WorkloadSecurityLink} workloadSecurityLink The workload security link to create.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/WorkloadSecurityLink}
     */
    this.createWorkloadSecurityLink = function(workloadSecurityLink, apiVersion) {
      return this.createWorkloadSecurityLinkWithHttpInfo(workloadSecurityLink, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete a Workload Security Link
     * Delete a Workload Security Link by ID.
     * @param {Number} workloadSecurityLinkID The ID number of the workload security link to delete.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteWorkloadSecurityLinkWithHttpInfo = function(workloadSecurityLinkID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'workloadSecurityLinkID' is set
      if (workloadSecurityLinkID === undefined || workloadSecurityLinkID === null) {
        throw new Error("Missing the required parameter 'workloadSecurityLinkID' when calling deleteWorkloadSecurityLink");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling deleteWorkloadSecurityLink");
      }


      var pathParams = {
        'workloadSecurityLinkID': workloadSecurityLinkID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/workloadsecuritylinks/{workloadSecurityLinkID}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete a Workload Security Link
     * Delete a Workload Security Link by ID.
     * @param {Number} workloadSecurityLinkID The ID number of the workload security link to delete.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteWorkloadSecurityLink = function(workloadSecurityLinkID, apiVersion) {
      return this.deleteWorkloadSecurityLinkWithHttpInfo(workloadSecurityLinkID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe a Workload Security Link
     * Describe a Workload Security Link by ID.
     * @param {Number} workloadSecurityLinkID The ID number of the workload security link to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/WorkloadSecurityLink} and HTTP response
     */
    this.describeWorkloadSecurityLinksWithHttpInfo = function(workloadSecurityLinkID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'workloadSecurityLinkID' is set
      if (workloadSecurityLinkID === undefined || workloadSecurityLinkID === null) {
        throw new Error("Missing the required parameter 'workloadSecurityLinkID' when calling describeWorkloadSecurityLinks");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeWorkloadSecurityLinks");
      }


      var pathParams = {
        'workloadSecurityLinkID': workloadSecurityLinkID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = WorkloadSecurityLink;

      return this.apiClient.callApi(
        '/workloadsecuritylinks/{workloadSecurityLinkID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe a Workload Security Link
     * Describe a Workload Security Link by ID.
     * @param {Number} workloadSecurityLinkID The ID number of the workload security link to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/WorkloadSecurityLink}
     */
    this.describeWorkloadSecurityLinks = function(workloadSecurityLinkID, apiVersion) {
      return this.describeWorkloadSecurityLinksWithHttpInfo(workloadSecurityLinkID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Get migration information through the Workload Security Link
     * Get migration information through the Workload Security Link.
     * @param {Number} workloadSecurityLinkID The ID number of the Workload Security Link.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/MigrationInformation} and HTTP response
     */
    this.getMigrationInformationWithHttpInfo = function(workloadSecurityLinkID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'workloadSecurityLinkID' is set
      if (workloadSecurityLinkID === undefined || workloadSecurityLinkID === null) {
        throw new Error("Missing the required parameter 'workloadSecurityLinkID' when calling getMigrationInformation");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling getMigrationInformation");
      }


      var pathParams = {
        'workloadSecurityLinkID': workloadSecurityLinkID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = MigrationInformation;

      return this.apiClient.callApi(
        '/workloadsecuritylinks/{workloadSecurityLinkID}/migrationinformation', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Get migration information through the Workload Security Link
     * Get migration information through the Workload Security Link.
     * @param {Number} workloadSecurityLinkID The ID number of the Workload Security Link.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/MigrationInformation}
     */
    this.getMigrationInformation = function(workloadSecurityLinkID, apiVersion) {
      return this.getMigrationInformationWithHttpInfo(workloadSecurityLinkID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List Workload Security Links
     * List Workload Security Links.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/WorkloadSecurityLinks} and HTTP response
     */
    this.listWorkloadSecurityLinksWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listWorkloadSecurityLinks");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = WorkloadSecurityLinks;

      return this.apiClient.callApi(
        '/workloadsecuritylinks', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List Workload Security Links
     * List Workload Security Links.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/WorkloadSecurityLinks}
     */
    this.listWorkloadSecurityLinks = function(apiVersion) {
      return this.listWorkloadSecurityLinksWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update a Workload Security Link
     * Update a Workload Security Link.
     * @param {Number} workloadSecurityLinkID The ID number of the workload security link.
     * @param {module:model/WorkloadSecurityLink} workloadSecurityLink The workload security link to create.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/WorkloadSecurityLink} and HTTP response
     */
    this.modifyWorkloadSecurityLinkWithHttpInfo = function(workloadSecurityLinkID, workloadSecurityLink, apiVersion) {
      var postBody = workloadSecurityLink;

      // verify the required parameter 'workloadSecurityLinkID' is set
      if (workloadSecurityLinkID === undefined || workloadSecurityLinkID === null) {
        throw new Error("Missing the required parameter 'workloadSecurityLinkID' when calling modifyWorkloadSecurityLink");
      }

      // verify the required parameter 'workloadSecurityLink' is set
      if (workloadSecurityLink === undefined || workloadSecurityLink === null) {
        throw new Error("Missing the required parameter 'workloadSecurityLink' when calling modifyWorkloadSecurityLink");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling modifyWorkloadSecurityLink");
      }


      var pathParams = {
        'workloadSecurityLinkID': workloadSecurityLinkID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = WorkloadSecurityLink;

      return this.apiClient.callApi(
        '/workloadsecuritylinks/{workloadSecurityLinkID}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update a Workload Security Link
     * Update a Workload Security Link.
     * @param {Number} workloadSecurityLinkID The ID number of the workload security link.
     * @param {module:model/WorkloadSecurityLink} workloadSecurityLink The workload security link to create.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/WorkloadSecurityLink}
     */
    this.modifyWorkloadSecurityLink = function(workloadSecurityLinkID, workloadSecurityLink, apiVersion) {
      return this.modifyWorkloadSecurityLinkWithHttpInfo(workloadSecurityLinkID, workloadSecurityLink, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
