/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AWSRegion'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AWSRegion'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.AWSConnector = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.AWSRegion);
  }
}(this, function(ApiClient, AWSRegion) {
  'use strict';




  /**
   * The AWSConnector model module.
   * @module model/AWSConnector
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>AWSConnector</code>.
   * Defines an AWS Cloud Connector that is used to retrieve information from AWS.
   * @alias module:model/AWSConnector
   * @class
   */
  var exports = function() {
    var _this = this;














  };

  /**
   * Constructs a <code>AWSConnector</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AWSConnector} obj Optional instance to populate.
   * @return {module:model/AWSConnector} The populated <code>AWSConnector</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('displayName')) {
        obj['displayName'] = ApiClient.convertToType(data['displayName'], 'String');
      }
      if (data.hasOwnProperty('accountId')) {
        obj['accountId'] = ApiClient.convertToType(data['accountId'], 'String');
      }
      if (data.hasOwnProperty('accountAlias')) {
        obj['accountAlias'] = ApiClient.convertToType(data['accountAlias'], 'String');
      }
      if (data.hasOwnProperty('accessKey')) {
        obj['accessKey'] = ApiClient.convertToType(data['accessKey'], 'String');
      }
      if (data.hasOwnProperty('secretKey')) {
        obj['secretKey'] = ApiClient.convertToType(data['secretKey'], 'String');
      }
      if (data.hasOwnProperty('seedRegion')) {
        obj['seedRegion'] = ApiClient.convertToType(data['seedRegion'], 'String');
      }
      if (data.hasOwnProperty('useInstanceRole')) {
        obj['useInstanceRole'] = ApiClient.convertToType(data['useInstanceRole'], 'Boolean');
      }
      if (data.hasOwnProperty('crossAccountRoleArn')) {
        obj['crossAccountRoleArn'] = ApiClient.convertToType(data['crossAccountRoleArn'], 'String');
      }
      if (data.hasOwnProperty('lastSyncTime')) {
        obj['lastSyncTime'] = ApiClient.convertToType(data['lastSyncTime'], 'Number');
      }
      if (data.hasOwnProperty('syncedRegions')) {
        obj['syncedRegions'] = ApiClient.convertToType(data['syncedRegions'], [AWSRegion]);
      }
      if (data.hasOwnProperty('workspacesEnabled')) {
        obj['workspacesEnabled'] = ApiClient.convertToType(data['workspacesEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('stsRegionalClientEnabled')) {
        obj['stsRegionalClientEnabled'] = ApiClient.convertToType(data['stsRegionalClientEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * The AWS Connector's display name in DSM.
   * @member {String} displayName
   */
  exports.prototype['displayName'] = undefined;
  /**
   * The AWS Account ID. Searchable as String.
   * @member {String} accountId
   */
  exports.prototype['accountId'] = undefined;
  /**
   * The AWS Account Alias. Searchable as String.
   * @member {String} accountAlias
   */
  exports.prototype['accountAlias'] = undefined;
  /**
   * The AWS Access Key of the account. If used, Cross Account Role ARN is not required. Searchable as String.
   * @member {String} accessKey
   */
  exports.prototype['accessKey'] = undefined;
  /**
   * The AWS Secret Key required to add the connector using an Access Key. Not present in returned objects.
   * @member {String} secretKey
   */
  exports.prototype['secretKey'] = undefined;
  /**
   * The region to initialize the EC2 client in. This is an advanced option used if you want to access special regions. Searchable as String.
   * @member {String} seedRegion
   */
  exports.prototype['seedRegion'] = undefined;
  /**
   * Specifies whether or not to use the DSM instance role to add the AWS Connector instead of an Access Key or a Cross Account Role ARN.
   * @member {Boolean} useInstanceRole
   */
  exports.prototype['useInstanceRole'] = undefined;
  /**
   * The Cross Account Role ARN of the AWS account. If used, Access Key is not required. Searchable as String.
   * @member {String} crossAccountRoleArn
   */
  exports.prototype['crossAccountRoleArn'] = undefined;
  /**
   * Timestamp of the last time the AWS Connector was successfully synchronized, in milliseconds since epoch. Searchable as Date.
   * @member {Number} lastSyncTime
   */
  exports.prototype['lastSyncTime'] = undefined;
  /**
   * The list of AWS regions that have been synchronized for the connector.
   * @member {Array.<module:model/AWSRegion>} syncedRegions
   */
  exports.prototype['syncedRegions'] = undefined;
  /**
   * A flag controlling whether or not Amazon Workspaces are enabled for the connector. Searchable as Boolean. Default is false.
   * @member {Boolean} workspacesEnabled
   */
  exports.prototype['workspacesEnabled'] = undefined;
  /**
   * A flag controlling whether or not the user is enabled Amazon STS client to use the region endpoint for the connector. Searchable as Boolean. Default is false.
   * @member {Boolean} stsRegionalClientEnabled
   */
  exports.prototype['stsRegionalClientEnabled'] = undefined;
  /**
   * The Deep Security internal ID of the AWS Cloud Connector. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;



  return exports;
}));



