/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ComputerModuleStatus'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ComputerModuleStatus'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ApplicationControlComputerExtension = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.ComputerModuleStatus);
  }
}(this, function(ApiClient, ComputerModuleStatus) {
  'use strict';




  /**
   * The ApplicationControlComputerExtension model module.
   * @module model/ApplicationControlComputerExtension
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>ApplicationControlComputerExtension</code>.
   * Computer-level configuration for the Application Control module. Null for tenants for whom Application Control is hidden.
   * @alias module:model/ApplicationControlComputerExtension
   * @class
   */
  var exports = function() {
    var _this = this;










  };

  /**
   * Constructs a <code>ApplicationControlComputerExtension</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ApplicationControlComputerExtension} obj Optional instance to populate.
   * @return {module:model/ApplicationControlComputerExtension} The populated <code>ApplicationControlComputerExtension</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('moduleStatus')) {
        obj['moduleStatus'] = ComputerModuleStatus.constructFromObject(data['moduleStatus']);
      }
      if (data.hasOwnProperty('blockUnrecognized')) {
        obj['blockUnrecognized'] = ApiClient.convertToType(data['blockUnrecognized'], 'Boolean');
      }
      if (data.hasOwnProperty('rulesetID')) {
        obj['rulesetID'] = ApiClient.convertToType(data['rulesetID'], 'Number');
      }
      if (data.hasOwnProperty('trustRulesetID')) {
        obj['trustRulesetID'] = ApiClient.convertToType(data['trustRulesetID'], 'String');
      }
      if (data.hasOwnProperty('maintenanceModeStatus')) {
        obj['maintenanceModeStatus'] = ApiClient.convertToType(data['maintenanceModeStatus'], 'String');
      }
      if (data.hasOwnProperty('maintenanceModeDuration')) {
        obj['maintenanceModeDuration'] = ApiClient.convertToType(data['maintenanceModeDuration'], 'Number');
      }
      if (data.hasOwnProperty('maintenanceModeStartTime')) {
        obj['maintenanceModeStartTime'] = ApiClient.convertToType(data['maintenanceModeStartTime'], 'Number');
      }
      if (data.hasOwnProperty('maintenanceModeEndTime')) {
        obj['maintenanceModeEndTime'] = ApiClient.convertToType(data['maintenanceModeEndTime'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Module state. The 'inherited' value is write-only.
   * @member {module:model/ApplicationControlComputerExtension.StateEnum} state
   */
  exports.prototype['state'] = undefined;
  /**
   * @member {module:model/ComputerModuleStatus} moduleStatus
   */
  exports.prototype['moduleStatus'] = undefined;
  /**
   * Controls whether to block unrecognized software until it is explicitly allowed. Set to true to block.
   * @member {Boolean} blockUnrecognized
   */
  exports.prototype['blockUnrecognized'] = undefined;
  /**
   * ID of the shared allowlist ruleset.
   * @member {Number} rulesetID
   */
  exports.prototype['rulesetID'] = undefined;
  /**
   * ID of the trust ruleset. An empty string will set it to \"None\" and assigning a value of 0 will set it to \"Inherited\".
   * @member {String} trustRulesetID
   */
  exports.prototype['trustRulesetID'] = undefined;
  /**
   * Maintenance mode status.
   * @member {module:model/ApplicationControlComputerExtension.MaintenanceModeStatusEnum} maintenanceModeStatus
   */
  exports.prototype['maintenanceModeStatus'] = undefined;
  /**
   * Duration of maintenance mode in minutes.
   * @member {Number} maintenanceModeDuration
   */
  exports.prototype['maintenanceModeDuration'] = undefined;
  /**
   * Timestamp of the date the maintenanceMode was started, in milliseconds since epoch.
   * @member {Number} maintenanceModeStartTime
   */
  exports.prototype['maintenanceModeStartTime'] = undefined;
  /**
   * Timestamp of the date the maintenanceMode was ended, in milliseconds since epoch.
   * @member {Number} maintenanceModeEndTime
   */
  exports.prototype['maintenanceModeEndTime'] = undefined;


  /**
   * Allowed values for the <code>state</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StateEnum = {
    /**
     * value: "inherited"
     * @const
     */
    "inherited": "inherited",
    /**
     * value: "on"
     * @const
     */
    "on": "on",
    /**
     * value: "off"
     * @const
     */
    "off": "off"  };

  /**
   * Allowed values for the <code>maintenanceModeStatus</code> property.
   * @enum {String}
   * @readonly
   */
  exports.MaintenanceModeStatusEnum = {
    /**
     * value: "off"
     * @const
     */
    "off": "off",
    /**
     * value: "start-requested"
     * @const
     */
    "start-requested": "start-requested",
    /**
     * value: "on"
     * @const
     */
    "on": "on",
    /**
     * value: "stop-requested"
     * @const
     */
    "stop-requested": "stop-requested",
    /**
     * value: "reset-duration-requested"
     * @const
     */
    "reset-duration-requested": "reset-duration-requested"  };


  return exports;
}));



