/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/TrustRuleAttribute'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./TrustRuleAttribute'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ApplicationControlTrustRule = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.TrustRuleAttribute);
  }
}(this, function(ApiClient, TrustRuleAttribute) {
  'use strict';




  /**
   * The ApplicationControlTrustRule model module.
   * @module model/ApplicationControlTrustRule
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>ApplicationControlTrustRule</code>.
   * TrustRuleset rule details.
   * @alias module:model/ApplicationControlTrustRule
   * @class
   */
  var exports = function() {
    var _this = this;










  };

  /**
   * Constructs a <code>ApplicationControlTrustRule</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ApplicationControlTrustRule} obj Optional instance to populate.
   * @return {module:model/ApplicationControlTrustRule} The populated <code>ApplicationControlTrustRule</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('isAssigned')) {
        obj['isAssigned'] = ApiClient.convertToType(data['isAssigned'], 'Boolean');
      }
      if (data.hasOwnProperty('createdTime')) {
        obj['createdTime'] = ApiClient.convertToType(data['createdTime'], 'Number');
      }
      if (data.hasOwnProperty('lastUpdatedTime')) {
        obj['lastUpdatedTime'] = ApiClient.convertToType(data['lastUpdatedTime'], 'Number');
      }
      if (data.hasOwnProperty('rulesetIDs')) {
        obj['rulesetIDs'] = ApiClient.convertToType(data['rulesetIDs'], ['Number']);
      }
      if (data.hasOwnProperty('attributes')) {
        obj['attributes'] = ApiClient.convertToType(data['attributes'], [TrustRuleAttribute]);
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Type of the rule. Searchable as Choice.
   * @member {module:model/ApplicationControlTrustRule.TypeEnum} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Name of the trust rule. Searchable as String.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Description of the trust rule. Searchable as String.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Whether the rule is assigned to any rulesets
   * @member {Boolean} isAssigned
   */
  exports.prototype['isAssigned'] = undefined;
  /**
   * Timestamp of the trust rule's creation, in milliseconds since epoch. Searchable as Date.
   * @member {Number} createdTime
   */
  exports.prototype['createdTime'] = undefined;
  /**
   * Timestamp of when the trust rule was last updated, in milliseconds since epoch. Searchable as Date.
   * @member {Number} lastUpdatedTime
   */
  exports.prototype['lastUpdatedTime'] = undefined;
  /**
   * IDs of all rulesets that the rule is assigned to.
   * @member {Array.<Number>} rulesetIDs
   */
  exports.prototype['rulesetIDs'] = undefined;
  /**
   * Attributes that define the trust rule.
   * @member {Array.<module:model/TrustRuleAttribute>} attributes
   */
  exports.prototype['attributes'] = undefined;
  /**
   * ID of the trust rule. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;


  /**
   * Allowed values for the <code>type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TypeEnum = {
    /**
     * value: "allowFromSourceTarget"
     * @const
     */
    "allowFromSourceTarget": "allowFromSourceTarget",
    /**
     * value: "allowFromSource"
     * @const
     */
    "allowFromSource": "allowFromSource",
    /**
     * value: "allowByTarget"
     * @const
     */
    "allowByTarget": "allowByTarget",
    /**
     * value: "ignoreFromSource"
     * @const
     */
    "ignoreFromSource": "ignoreFromSource",
    /**
     * value: "blockByTarget"
     * @const
     */
    "blockByTarget": "blockByTarget"  };


  return exports;
}));



