/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.AzureConnector = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The AzureConnector model module.
   * @module model/AzureConnector
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>AzureConnector</code>.
   * Defines an Azure Cloud Connector that is used to retrieve information from Azure.
   * @alias module:model/AzureConnector
   * @class
   */
  var exports = function() {
    var _this = this;














  };

  /**
   * Constructs a <code>AzureConnector</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AzureConnector} obj Optional instance to populate.
   * @return {module:model/AzureConnector} The populated <code>AzureConnector</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('azureTenantID')) {
        obj['azureTenantID'] = ApiClient.convertToType(data['azureTenantID'], 'String');
      }
      if (data.hasOwnProperty('subscriptionID')) {
        obj['subscriptionID'] = ApiClient.convertToType(data['subscriptionID'], 'String');
      }
      if (data.hasOwnProperty('azureAdApplicationID')) {
        obj['azureAdApplicationID'] = ApiClient.convertToType(data['azureAdApplicationID'], 'String');
      }
      if (data.hasOwnProperty('azureAdApplicationSecret')) {
        obj['azureAdApplicationSecret'] = ApiClient.convertToType(data['azureAdApplicationSecret'], 'String');
      }
      if (data.hasOwnProperty('azureAdApplicationCertificate')) {
        obj['azureAdApplicationCertificate'] = ApiClient.convertToType(data['azureAdApplicationCertificate'], 'String');
      }
      if (data.hasOwnProperty('azureAdApplicationPrivateKey')) {
        obj['azureAdApplicationPrivateKey'] = ApiClient.convertToType(data['azureAdApplicationPrivateKey'], 'String');
      }
      if (data.hasOwnProperty('azureAdApplicationPrivateKeySecret')) {
        obj['azureAdApplicationPrivateKeySecret'] = ApiClient.convertToType(data['azureAdApplicationPrivateKeySecret'], 'String');
      }
      if (data.hasOwnProperty('azureAdApplicationCertificateExpirationDate')) {
        obj['azureAdApplicationCertificateExpirationDate'] = ApiClient.convertToType(data['azureAdApplicationCertificateExpirationDate'], 'Number');
      }
      if (data.hasOwnProperty('resourceApiEndPoint')) {
        obj['resourceApiEndPoint'] = ApiClient.convertToType(data['resourceApiEndPoint'], 'String');
      }
      if (data.hasOwnProperty('loginApiEndPoint')) {
        obj['loginApiEndPoint'] = ApiClient.convertToType(data['loginApiEndPoint'], 'String');
      }
      if (data.hasOwnProperty('lastSyncTime')) {
        obj['lastSyncTime'] = ApiClient.convertToType(data['lastSyncTime'], 'Number');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * The Azure Connector's display name in DSM. Searchable as String.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * The Microsoft Entra tenant ID (formly Azure Tenant/Active Directory ID). Searchable as String.
   * @member {String} azureTenantID
   */
  exports.prototype['azureTenantID'] = undefined;
  /**
   * The Azure Subscription ID. Searchable as String.
   * @member {String} subscriptionID
   */
  exports.prototype['subscriptionID'] = undefined;
  /**
   * The Microsoft Entra ID (formerly Azure Active Directory) Application ID. Searchable as String.
   * @member {String} azureAdApplicationID
   */
  exports.prototype['azureAdApplicationID'] = undefined;
  /**
   * The Microsoft Entra ID (formerly Azure Active Directory) Application secret/password. Not present in returned objects.
   * @member {String} azureAdApplicationSecret
   */
  exports.prototype['azureAdApplicationSecret'] = undefined;
  /**
   * The Microsoft Entra ID (formerly Azure Active Directory) Application certificate for authentication. The certificate should be in X.509 PEM format and encoded in Base64. Not present in returned objects.
   * @member {String} azureAdApplicationCertificate
   */
  exports.prototype['azureAdApplicationCertificate'] = undefined;
  /**
   * The Microsoft Entra ID (formerly Azure Active Directory) Application private key of azureAdApplicationCertificate. The private key should be in PEM format and encoded in Base64. Not present in returned objects.
   * @member {String} azureAdApplicationPrivateKey
   */
  exports.prototype['azureAdApplicationPrivateKey'] = undefined;
  /**
   * The optional secret of Microsoft Entra ID (formerly Azure Active Directory) Application private key if the private key is protected with secret/password.
   * @member {String} azureAdApplicationPrivateKeySecret
   */
  exports.prototype['azureAdApplicationPrivateKeySecret'] = undefined;
  /**
   * Expiration timestamp of the the Microsoft Entra ID (formerly Azure Active Directory) Application certificate, in milliseconds since epoch.
   * @member {Number} azureAdApplicationCertificateExpirationDate
   */
  exports.prototype['azureAdApplicationCertificateExpirationDate'] = undefined;
  /**
   * The optional Azure Resource REST API endpoint. Will auto detect by DSM VM location if not provided. This is an advanced option used if you want to access private or confidential cloud. Be aware that managing Azure Government computers outside Azure Government would break ITAR compliance.
   * @member {String} resourceApiEndPoint
   */
  exports.prototype['resourceApiEndPoint'] = undefined;
  /**
   * The optional Microsoft Entra ID (formerly Azure Active Directory) Login/Authentication API endpoint. Will auto detect by DSM VM location if not provided. This is an advanced option used if you want to access private or confidential cloud. Be aware that managing Azure Government computers outside Azure Government would break ITAR compliance.
   * @member {String} loginApiEndPoint
   */
  exports.prototype['loginApiEndPoint'] = undefined;
  /**
   * Timestamp of the last time the Azure Connector was successfully synchronized, in milliseconds since epoch.
   * @member {Number} lastSyncTime
   */
  exports.prototype['lastSyncTime'] = undefined;
  /**
   * Azure Connector ID. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;



  return exports;
}));



