/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CommonObjectInfo'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CommonObjectInfo'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.CommonObjectMapping = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.CommonObjectInfo);
  }
}(this, function(ApiClient, CommonObjectInfo) {
  'use strict';




  /**
   * The CommonObjectMapping model module.
   * @module model/CommonObjectMapping
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>CommonObjectMapping</code>.
   * The mapping of a common object between this Deep Security Manager and Workload Security.
   * @alias module:model/CommonObjectMapping
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>CommonObjectMapping</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CommonObjectMapping} obj Optional instance to populate.
   * @return {module:model/CommonObjectMapping} The populated <code>CommonObjectMapping</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('migrateTo')) {
        obj['migrateTo'] = CommonObjectInfo.constructFromObject(data['migrateTo']);
      }
      if (data.hasOwnProperty('migrateFrom')) {
        obj['migrateFrom'] = CommonObjectInfo.constructFromObject(data['migrateFrom']);
      }
    }
    return obj;
  }

  /**
   * The common object in Workload Security.
   * @member {module:model/CommonObjectInfo} migrateTo
   */
  exports.prototype['migrateTo'] = undefined;
  /**
   * The common object in this Deep Security Manager.
   * @member {module:model/CommonObjectInfo} migrateFrom
   */
  exports.prototype['migrateFrom'] = undefined;



  return exports;
}));



