/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CommonObjectMapping', 'model/CommonObjectUnableToMigrate'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CommonObjectMapping'), require('./CommonObjectUnableToMigrate'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.CommonObjectMigrationTask = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.CommonObjectMapping, root.Deepsecurity.CommonObjectUnableToMigrate);
  }
}(this, function(ApiClient, CommonObjectMapping, CommonObjectUnableToMigrate) {
  'use strict';




  /**
   * The CommonObjectMigrationTask model module.
   * @module model/CommonObjectMigrationTask
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>CommonObjectMigrationTask</code>.
   * Task to migrate common objects
   * @alias module:model/CommonObjectMigrationTask
   * @class
   * @param type {module:model/CommonObjectMigrationTask.TypeEnum} Target type to move. Searchable as Choice.
   * @param objectIDs {Array.<Number>} Target IDs to move from type.
   */
  var exports = function(type, objectIDs) {
    var _this = this;

    _this['type'] = type;
    _this['objectIDs'] = objectIDs;








  };

  /**
   * Constructs a <code>CommonObjectMigrationTask</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CommonObjectMigrationTask} obj Optional instance to populate.
   * @return {module:model/CommonObjectMigrationTask} The populated <code>CommonObjectMigrationTask</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('objectIDs')) {
        obj['objectIDs'] = ApiClient.convertToType(data['objectIDs'], ['Number']);
      }
      if (data.hasOwnProperty('taskGUID')) {
        obj['taskGUID'] = ApiClient.convertToType(data['taskGUID'], 'String');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('created')) {
        obj['created'] = ApiClient.convertToType(data['created'], 'Number');
      }
      if (data.hasOwnProperty('lastUpdated')) {
        obj['lastUpdated'] = ApiClient.convertToType(data['lastUpdated'], 'Number');
      }
      if (data.hasOwnProperty('commonObjectMappings')) {
        obj['commonObjectMappings'] = ApiClient.convertToType(data['commonObjectMappings'], [CommonObjectMapping]);
      }
      if (data.hasOwnProperty('errorCode')) {
        obj['errorCode'] = ApiClient.convertToType(data['errorCode'], 'Number');
      }
      if (data.hasOwnProperty('commonObjectsUnableToMigrate')) {
        obj['commonObjectsUnableToMigrate'] = ApiClient.convertToType(data['commonObjectsUnableToMigrate'], [CommonObjectUnableToMigrate]);
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Target type to move. Searchable as Choice.
   * @member {module:model/CommonObjectMigrationTask.TypeEnum} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Target IDs to move from type.
   * @member {Array.<Number>} objectIDs
   */
  exports.prototype['objectIDs'] = undefined;
  /**
   * Task GUID on Workload Security. Searchable as String.
   * @member {String} taskGUID
   */
  exports.prototype['taskGUID'] = undefined;
  /**
   * The migration status.
   * @member {module:model/CommonObjectMigrationTask.StatusEnum} status
   */
  exports.prototype['status'] = undefined;
  /**
   * Timestamp when the CommonObjectMigrationTask was created, in milliseconds since epoch. Searchable as Date.
   * @member {Number} created
   */
  exports.prototype['created'] = undefined;
  /**
   * Timestamp when the CommonObjectMigrationTask was updated, in milliseconds since epoch. Searchable as Date.
   * @member {Number} lastUpdated
   */
  exports.prototype['lastUpdated'] = undefined;
  /**
   * The mapping table of common objects on this Deep Security Manager and the Workload Security.
   * @member {Array.<module:model/CommonObjectMapping>} commonObjectMappings
   */
  exports.prototype['commonObjectMappings'] = undefined;
  /**
   * The error code of the failed task.
   * @member {Number} errorCode
   */
  exports.prototype['errorCode'] = undefined;
  /**
   * The common objects that cannot be migrated.
   * @member {Array.<module:model/CommonObjectUnableToMigrate>} commonObjectsUnableToMigrate
   */
  exports.prototype['commonObjectsUnableToMigrate'] = undefined;
  /**
   * ID of the common object migration task.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;


  /**
   * Allowed values for the <code>type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TypeEnum = {
    /**
     * value: "directory-lists"
     * @const
     */
    "directory-lists": "directory-lists",
    /**
     * value: "file-extension-lists"
     * @const
     */
    "file-extension-lists": "file-extension-lists",
    /**
     * value: "file-lists"
     * @const
     */
    "file-lists": "file-lists",
    /**
     * value: "ip-lists"
     * @const
     */
    "ip-lists": "ip-lists",
    /**
     * value: "mac-lists"
     * @const
     */
    "mac-lists": "mac-lists",
    /**
     * value: "port-lists"
     * @const
     */
    "port-lists": "port-lists",
    /**
     * value: "contexts"
     * @const
     */
    "contexts": "contexts",
    /**
     * value: "stateful-configurations"
     * @const
     */
    "stateful-configurations": "stateful-configurations",
    /**
     * value: "schedules"
     * @const
     */
    "schedules": "schedules"  };

  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "requested"
     * @const
     */
    "requested": "requested",
    /**
     * value: "in-progress"
     * @const
     */
    "in-progress": "in-progress",
    /**
     * value: "complete"
     * @const
     */
    "complete": "complete",
    /**
     * value: "failed"
     * @const
     */
    "failed": "failed"  };


  return exports;
}));



