/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/WorkloadSecurityProxy', 'model/WorkloadSecurityRelayProxy'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./WorkloadSecurityProxy'), require('./WorkloadSecurityRelayProxy'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ComputerMoveTask = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.WorkloadSecurityProxy, root.Deepsecurity.WorkloadSecurityRelayProxy);
  }
}(this, function(ApiClient, WorkloadSecurityProxy, WorkloadSecurityRelayProxy) {
  'use strict';




  /**
   * The ComputerMoveTask model module.
   * @module model/ComputerMoveTask
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>ComputerMoveTask</code>.
   * Task to move a computer
   * @alias module:model/ComputerMoveTask
   * @class
   * @param computerID {Number} Target computer to move. Searchable as Numeric.
   */
  var exports = function(computerID) {
    var _this = this;











    _this['computerID'] = computerID;




  };

  /**
   * Constructs a <code>ComputerMoveTask</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ComputerMoveTask} obj Optional instance to populate.
   * @return {module:model/ComputerMoveTask} The populated <code>ComputerMoveTask</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('workloadSecurityPolicyID')) {
        obj['workloadSecurityPolicyID'] = ApiClient.convertToType(data['workloadSecurityPolicyID'], 'Number');
      }
      if (data.hasOwnProperty('workloadSecurityComputerGroupID')) {
        obj['workloadSecurityComputerGroupID'] = ApiClient.convertToType(data['workloadSecurityComputerGroupID'], 'Number');
      }
      if (data.hasOwnProperty('workloadSecurityRelayGroupID')) {
        obj['workloadSecurityRelayGroupID'] = ApiClient.convertToType(data['workloadSecurityRelayGroupID'], 'Number');
      }
      if (data.hasOwnProperty('workloadSecurityProxy')) {
        obj['workloadSecurityProxy'] = WorkloadSecurityProxy.constructFromObject(data['workloadSecurityProxy']);
      }
      if (data.hasOwnProperty('proxyIDToContactWorkloadSecurity')) {
        obj['proxyIDToContactWorkloadSecurity'] = ApiClient.convertToType(data['proxyIDToContactWorkloadSecurity'], 'Number');
      }
      if (data.hasOwnProperty('workloadSecurityRelayProxy')) {
        obj['workloadSecurityRelayProxy'] = WorkloadSecurityRelayProxy.constructFromObject(data['workloadSecurityRelayProxy']);
      }
      if (data.hasOwnProperty('proxyIDToContactWorkloadSecurityRelay')) {
        obj['proxyIDToContactWorkloadSecurityRelay'] = ApiClient.convertToType(data['proxyIDToContactWorkloadSecurityRelay'], 'Number');
      }
      if (data.hasOwnProperty('includeComputerOverrides')) {
        obj['includeComputerOverrides'] = ApiClient.convertToType(data['includeComputerOverrides'], 'Boolean');
      }
      if (data.hasOwnProperty('includeComputerDescription')) {
        obj['includeComputerDescription'] = ApiClient.convertToType(data['includeComputerDescription'], 'Boolean');
      }
      if (data.hasOwnProperty('referToLatestMigratedPolicy')) {
        obj['referToLatestMigratedPolicy'] = ApiClient.convertToType(data['referToLatestMigratedPolicy'], 'Boolean');
      }
      if (data.hasOwnProperty('computerID')) {
        obj['computerID'] = ApiClient.convertToType(data['computerID'], 'Number');
      }
      if (data.hasOwnProperty('moveState')) {
        obj['moveState'] = ApiClient.convertToType(data['moveState'], 'String');
      }
      if (data.hasOwnProperty('created')) {
        obj['created'] = ApiClient.convertToType(data['created'], 'Number');
      }
      if (data.hasOwnProperty('lastUpdated')) {
        obj['lastUpdated'] = ApiClient.convertToType(data['lastUpdated'], 'Number');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Policy ID in Workload Security.
   * @member {Number} workloadSecurityPolicyID
   */
  exports.prototype['workloadSecurityPolicyID'] = undefined;
  /**
   * Computer Group ID in Workload Security.
   * @member {Number} workloadSecurityComputerGroupID
   */
  exports.prototype['workloadSecurityComputerGroupID'] = undefined;
  /**
   * Relay Group ID in Workload Security.
   * @member {Number} workloadSecurityRelayGroupID
   */
  exports.prototype['workloadSecurityRelayGroupID'] = undefined;
  /**
   * Workload Security proxy for agent.
   * @member {module:model/WorkloadSecurityProxy} workloadSecurityProxy
   */
  exports.prototype['workloadSecurityProxy'] = undefined;
  /**
   * Deep Security proxy ID for the computer to contact to Workload Security.
   * @member {Number} proxyIDToContactWorkloadSecurity
   */
  exports.prototype['proxyIDToContactWorkloadSecurity'] = undefined;
  /**
   * Workload Security relay proxy of agent.
   * @member {module:model/WorkloadSecurityRelayProxy} workloadSecurityRelayProxy
   */
  exports.prototype['workloadSecurityRelayProxy'] = undefined;
  /**
   * Deep Security proxy ID for the computer to contact to Workload Security relays.
   * @member {Number} proxyIDToContactWorkloadSecurityRelay
   */
  exports.prototype['proxyIDToContactWorkloadSecurityRelay'] = undefined;
  /**
   * Controls whether the Computer Move Task moves setting is overridden at the computer level. Defaults to `true`.
   * @member {Boolean} includeComputerOverrides
   */
  exports.prototype['includeComputerOverrides'] = undefined;
  /**
   * Controls whether the Computer Move Task moves the hostname, display name, and description. Defaults to `true`.
   * @member {Boolean} includeComputerDescription
   */
  exports.prototype['includeComputerDescription'] = undefined;
  /**
   * Controls whether the last successfully migrated policies are assigned to the computers.
   * @member {Boolean} referToLatestMigratedPolicy
   */
  exports.prototype['referToLatestMigratedPolicy'] = undefined;
  /**
   * Target computer to move. Searchable as Numeric.
   * @member {Number} computerID
   */
  exports.prototype['computerID'] = undefined;
  /**
   * Move status
   * @member {module:model/ComputerMoveTask.MoveStateEnum} moveState
   */
  exports.prototype['moveState'] = undefined;
  /**
   * Timestamp when the ComputerMoveTask was created, in milliseconds since epoch. Searchable as Date.
   * @member {Number} created
   */
  exports.prototype['created'] = undefined;
  /**
   * Timestamp when the ComputerMoveTask was updated, in milliseconds since epoch. Searchable as Date.
   * @member {Number} lastUpdated
   */
  exports.prototype['lastUpdated'] = undefined;
  /**
   * ID of the ComputerMoveTask.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;


  /**
   * Allowed values for the <code>moveState</code> property.
   * @enum {String}
   * @readonly
   */
  exports.MoveStateEnum = {
    /**
     * value: "move-requested"
     * @const
     */
    "move-requested": "move-requested",
    /**
     * value: "moving"
     * @const
     */
    "moving": "moving",
    /**
     * value: "move-complete"
     * @const
     */
    "move-complete": "move-complete",
    /**
     * value: "move-failed"
     * @const
     */
    "move-failed": "move-failed",
    /**
     * value: "move-failed-no-response"
     * @const
     */
    "move-failed-no-response": "move-failed-no-response",
    /**
     * value: "move-failed-activation-failed"
     * @const
     */
    "move-failed-activation-failed": "move-failed-activation-failed",
    /**
     * value: "move-failed-unmanaged"
     * @const
     */
    "move-failed-unmanaged": "move-failed-unmanaged"  };


  return exports;
}));



