/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ComputerUnableToMove = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The ComputerUnableToMove model module.
   * @module model/ComputerUnableToMove
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>ComputerUnableToMove</code>.
   * The computer that cannot be moved.
   * @alias module:model/ComputerUnableToMove
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>ComputerUnableToMove</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ComputerUnableToMove} obj Optional instance to populate.
   * @return {module:model/ComputerUnableToMove} The populated <code>ComputerUnableToMove</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('computerID')) {
        obj['computerID'] = ApiClient.convertToType(data['computerID'], 'Number');
      }
      if (data.hasOwnProperty('computerName')) {
        obj['computerName'] = ApiClient.convertToType(data['computerName'], 'String');
      }
      if (data.hasOwnProperty('errorMessage')) {
        obj['errorMessage'] = ApiClient.convertToType(data['errorMessage'], 'String');
      }
    }
    return obj;
  }

  /**
   * ID of the computer that cannot be moved.
   * @member {Number} computerID
   */
  exports.prototype['computerID'] = undefined;
  /**
   * Name of the computer that cannot be moved.
   * @member {String} computerName
   */
  exports.prototype['computerName'] = undefined;
  /**
   * Error message of the computer that cannot be moved.
   * @member {String} errorMessage
   */
  exports.prototype['errorMessage'] = undefined;



  return exports;
}));



