/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ConnectorMigrationTask = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The ConnectorMigrationTask model module.
   * @module model/ConnectorMigrationTask
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>ConnectorMigrationTask</code>.
   * Task to migrate a connector
   * @alias module:model/ConnectorMigrationTask
   * @class
   */
  var exports = function() {
    var _this = this;







  };

  /**
   * Constructs a <code>ConnectorMigrationTask</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ConnectorMigrationTask} obj Optional instance to populate.
   * @return {module:model/ConnectorMigrationTask} The populated <code>ConnectorMigrationTask</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
      if (data.hasOwnProperty('connectorID')) {
        obj['connectorID'] = ApiClient.convertToType(data['connectorID'], 'Number');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('errorCode')) {
        obj['errorCode'] = ApiClient.convertToType(data['errorCode'], 'Number');
      }
      if (data.hasOwnProperty('created')) {
        obj['created'] = ApiClient.convertToType(data['created'], 'Date');
      }
      if (data.hasOwnProperty('lastUpdated')) {
        obj['lastUpdated'] = ApiClient.convertToType(data['lastUpdated'], 'Date');
      }
    }
    return obj;
  }

  /**
   * ID of the ConnectorMigrationTask.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;
  /**
   * ID of the Connector.
   * @member {Number} connectorID
   */
  exports.prototype['connectorID'] = undefined;
  /**
   * Migration status.
   * @member {module:model/ConnectorMigrationTask.StatusEnum} status
   */
  exports.prototype['status'] = undefined;
  /**
   * The error code of the failed task.
   * @member {Number} errorCode
   */
  exports.prototype['errorCode'] = undefined;
  /**
   * Timestamp when the ConnectorMigrationTask was created, in milliseconds since epoch. Searchable as Date.
   * @member {Date} created
   */
  exports.prototype['created'] = undefined;
  /**
   * Timestamp when the ConnectorMigrationTask was updated, in milliseconds since epoch. Searchable as Date.
   * @member {Date} lastUpdated
   */
  exports.prototype['lastUpdated'] = undefined;


  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "requested"
     * @const
     */
    "requested": "requested",
    /**
     * value: "in-progress"
     * @const
     */
    "in-progress": "in-progress",
    /**
     * value: "complete"
     * @const
     */
    "complete": "complete",
    /**
     * value: "failed"
     * @const
     */
    "failed": "failed"  };


  return exports;
}));



