/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.Context = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Context model module.
   * @module model/Context
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>Context</code>.
   * Firewall context information.
   * @alias module:model/Context
   * @class
   */
  var exports = function() {
    var _this = this;










  };

  /**
   * Constructs a <code>Context</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Context} obj Optional instance to populate.
   * @return {module:model/Context} The populated <code>Context</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('minimumAgentVersion')) {
        obj['minimumAgentVersion'] = ApiClient.convertToType(data['minimumAgentVersion'], 'String');
      }
      if (data.hasOwnProperty('localConnectionsEnabled')) {
        obj['localConnectionsEnabled'] = ApiClient.convertToType(data['localConnectionsEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('remoteConnectionsEnabled')) {
        obj['remoteConnectionsEnabled'] = ApiClient.convertToType(data['remoteConnectionsEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('noConnectionEnabled')) {
        obj['noConnectionEnabled'] = ApiClient.convertToType(data['noConnectionEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('noInternetEnabled')) {
        obj['noInternetEnabled'] = ApiClient.convertToType(data['noInternetEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('restrictedInterfacesEnabled')) {
        obj['restrictedInterfacesEnabled'] = ApiClient.convertToType(data['restrictedInterfacesEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Name of the context. Searchable as String.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Description of the context. Searchable as String.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Minimum supported agent version.
   * @member {String} minimumAgentVersion
   */
  exports.prototype['minimumAgentVersion'] = undefined;
  /**
   * Specifies whether the context applies to connections that are locally conntected to a domain. Set to true to apply to locally connected.
   * @member {Boolean} localConnectionsEnabled
   */
  exports.prototype['localConnectionsEnabled'] = undefined;
  /**
   * Specifies whether the context applies to connections that are remotely conntected to a domain. Set to true to apply to remotely connected.
   * @member {Boolean} remoteConnectionsEnabled
   */
  exports.prototype['remoteConnectionsEnabled'] = undefined;
  /**
   * Specifies whether the context applies to connections that are no connection enabled. Set to true to apply to no connection enabled.
   * @member {Boolean} noConnectionEnabled
   */
  exports.prototype['noConnectionEnabled'] = undefined;
  /**
   * Specifies whether the context applies to connections that are neither connection nor Internet enabled. Set to true to apply.
   * @member {Boolean} noInternetEnabled
   */
  exports.prototype['noInternetEnabled'] = undefined;
  /**
   * Controls if the firewall contents are restricted from view and duplication. Set to true if it's restricted. Searchable as Boolean.
   * @member {Boolean} restrictedInterfacesEnabled
   */
  exports.prototype['restrictedInterfacesEnabled'] = undefined;
  /**
   * ID of the context. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;



  return exports;
}));



