/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.DailyScheduleParameters = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The DailyScheduleParameters model module.
   * @module model/DailyScheduleParameters
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>DailyScheduleParameters</code>.
   * Details for the daily schedule of a scheduled task.
   * @alias module:model/DailyScheduleParameters
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>DailyScheduleParameters</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/DailyScheduleParameters} obj Optional instance to populate.
   * @return {module:model/DailyScheduleParameters} The populated <code>DailyScheduleParameters</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('startTime')) {
        obj['startTime'] = ApiClient.convertToType(data['startTime'], 'Number');
      }
      if (data.hasOwnProperty('frequencyType')) {
        obj['frequencyType'] = ApiClient.convertToType(data['frequencyType'], 'String');
      }
      if (data.hasOwnProperty('customInterval')) {
        obj['customInterval'] = ApiClient.convertToType(data['customInterval'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Date/Time when the task should run.
   * @member {Number} startTime
   */
  exports.prototype['startTime'] = undefined;
  /**
   * Frequency type.
   * @member {module:model/DailyScheduleParameters.FrequencyTypeEnum} frequencyType
   */
  exports.prototype['frequencyType'] = undefined;
  /**
   * Custom interval.
   * @member {Number} customInterval
   */
  exports.prototype['customInterval'] = undefined;


  /**
   * Allowed values for the <code>frequencyType</code> property.
   * @enum {String}
   * @readonly
   */
  exports.FrequencyTypeEnum = {
    /**
     * value: "everyday"
     * @const
     */
    "everyday": "everyday",
    /**
     * value: "weekdays"
     * @const
     */
    "weekdays": "weekdays",
    /**
     * value: "custom"
     * @const
     */
    "custom": "custom"  };


  return exports;
}));



