/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/UsbDeviceRights'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./UsbDeviceRights'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.DeviceControlRights = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.UsbDeviceRights);
  }
}(this, function(ApiClient, UsbDeviceRights) {
  'use strict';




  /**
   * The DeviceControlRights model module.
   * @module model/DeviceControlRights
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>DeviceControlRights</code>.
   * Device control permission details.
   * @alias module:model/DeviceControlRights
   * @class
   */
  var exports = function() {
    var _this = this;


  };

  /**
   * Constructs a <code>DeviceControlRights</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/DeviceControlRights} obj Optional instance to populate.
   * @return {module:model/DeviceControlRights} The populated <code>DeviceControlRights</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('usbDeviceRights')) {
        obj['usbDeviceRights'] = UsbDeviceRights.constructFromObject(data['usbDeviceRights']);
      }
    }
    return obj;
  }

  /**
   * Rights related to USB device.
   * @member {module:model/UsbDeviceRights} usbDeviceRights
   */
  exports.prototype['usbDeviceRights'] = undefined;



  return exports;
}));



