/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/EventBasedTaskAction', 'model/EventBasedTaskCondition'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./EventBasedTaskAction'), require('./EventBasedTaskCondition'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.EventBasedTask = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.EventBasedTaskAction, root.Deepsecurity.EventBasedTaskCondition);
  }
}(this, function(ApiClient, EventBasedTaskAction, EventBasedTaskCondition) {
  'use strict';




  /**
   * The EventBasedTask model module.
   * @module model/EventBasedTask
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>EventBasedTask</code>.
   * Defines an event based task. Events based tasks automatically perform specific Deep Security Manager triggered by an event.
   * @alias module:model/EventBasedTask
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>EventBasedTask</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/EventBasedTask} obj Optional instance to populate.
   * @return {module:model/EventBasedTask} The populated <code>EventBasedTask</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('enabled')) {
        obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
      }
      if (data.hasOwnProperty('lastRunTime')) {
        obj['lastRunTime'] = ApiClient.convertToType(data['lastRunTime'], 'Number');
      }
      if (data.hasOwnProperty('actions')) {
        obj['actions'] = ApiClient.convertToType(data['actions'], [EventBasedTaskAction]);
      }
      if (data.hasOwnProperty('conditions')) {
        obj['conditions'] = ApiClient.convertToType(data['conditions'], [EventBasedTaskCondition]);
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Name of event based task. Searchable as String.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Type of scheduled task. Searchable as Choice.
   * @member {module:model/EventBasedTask.TypeEnum} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Indicates whether or not the event based task is enabled. Searchable as Boolean.
   * @member {Boolean} enabled
   */
  exports.prototype['enabled'] = undefined;
  /**
   * The last time this event based task was run, or null if never run. Searchable as Date.
   * @member {Number} lastRunTime
   */
  exports.prototype['lastRunTime'] = undefined;
  /**
   * List of actions to perform when an event based task condition is met.
   * @member {Array.<module:model/EventBasedTaskAction>} actions
   */
  exports.prototype['actions'] = undefined;
  /**
   * List of conditions that must be met in order for an event based task to run its actions.
   * @member {Array.<module:model/EventBasedTaskCondition>} conditions
   */
  exports.prototype['conditions'] = undefined;
  /**
   * Event based task identifier. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;


  /**
   * Allowed values for the <code>type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TypeEnum = {
    /**
     * value: "computer-created-by-system"
     * @const
     */
    "computer-created-by-system": "computer-created-by-system",
    /**
     * value: "computer-moved-by-system"
     * @const
     */
    "computer-moved-by-system": "computer-moved-by-system",
    /**
     * value: "agent-initiated-activation"
     * @const
     */
    "agent-initiated-activation": "agent-initiated-activation",
    /**
     * value: "agent-ip-changed"
     * @const
     */
    "agent-ip-changed": "agent-ip-changed",
    /**
     * value: "nsx-protection-changed"
     * @const
     */
    "nsx-protection-changed": "nsx-protection-changed",
    /**
     * value: "computer-powered-on-by-system"
     * @const
     */
    "computer-powered-on-by-system": "computer-powered-on-by-system"  };


  return exports;
}));



