/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.EventBasedTaskCondition = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The EventBasedTaskCondition model module.
   * @module model/EventBasedTaskCondition
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>EventBasedTaskCondition</code>.
   * Defines a condition that must be met in order for an event based task to run its actions.
   * @alias module:model/EventBasedTaskCondition
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>EventBasedTaskCondition</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/EventBasedTaskCondition} obj Optional instance to populate.
   * @return {module:model/EventBasedTaskCondition} The populated <code>EventBasedTaskCondition</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('field')) {
        obj['field'] = ApiClient.convertToType(data['field'], 'String');
      }
      if (data.hasOwnProperty('key')) {
        obj['key'] = ApiClient.convertToType(data['key'], 'String');
      }
      if (data.hasOwnProperty('value')) {
        obj['value'] = ApiClient.convertToType(data['value'], 'String');
      }
    }
    return obj;
  }

  /**
   * The event field to match against when evaluating this condition. Use `tag` enum to specify \"Cloud Instance Metadata\" which correspond to \"AWS Tags\", \"Azure Tags\" or \"GCP Labels\".
   * @member {module:model/EventBasedTaskCondition.FieldEnum} field
   */
  exports.prototype['field'] = undefined;
  /**
   * If matching against a key/value field, then the key to match when evaluating this condition.
   * @member {String} key
   */
  exports.prototype['key'] = undefined;
  /**
   * The value to match when evaluating this condition.
   * @member {String} value
   */
  exports.prototype['value'] = undefined;


  /**
   * Allowed values for the <code>field</code> property.
   * @enum {String}
   * @readonly
   */
  exports.FieldEnum = {
    /**
     * value: "hostname"
     * @const
     */
    "hostname": "hostname",
    /**
     * value: "vcenter"
     * @const
     */
    "vcenter": "vcenter",
    /**
     * value: "cloudProvider"
     * @const
     */
    "cloudProvider": "cloudProvider",
    /**
     * value: "securityGroup"
     * @const
     */
    "securityGroup": "securityGroup",
    /**
     * value: "imageId"
     * @const
     */
    "imageId": "imageId",
    /**
     * value: "esx"
     * @const
     */
    "esx": "esx",
    /**
     * value: "folder"
     * @const
     */
    "folder": "folder",
    /**
     * value: "platform"
     * @const
     */
    "platform": "platform",
    /**
     * value: "applianceProtectionAvailable"
     * @const
     */
    "applianceProtectionAvailable": "applianceProtectionAvailable",
    /**
     * value: "applianceProtectionActivated"
     * @const
     */
    "applianceProtectionActivated": "applianceProtectionActivated",
    /**
     * value: "lastUsedIP"
     * @const
     */
    "lastUsedIP": "lastUsedIP",
    /**
     * value: "tag"
     * @const
     */
    "tag": "tag",
    /**
     * value: "nsxSecurityGroup"
     * @const
     */
    "nsxSecurityGroup": "nsxSecurityGroup",
    /**
     * value: "cloudVendor"
     * @const
     */
    "cloudVendor": "cloudVendor",
    /**
     * value: "gcpNetworkTag"
     * @const
     */
    "gcpNetworkTag": "gcpNetworkTag"  };


  return exports;
}));



