/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.GCPConnector = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The GCPConnector model module.
   * @module model/GCPConnector
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>GCPConnector</code>.
   * Everything about GCP connector.
   * @alias module:model/GCPConnector
   * @class
   */
  var exports = function() {
    var _this = this;







  };

  /**
   * Constructs a <code>GCPConnector</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/GCPConnector} obj Optional instance to populate.
   * @return {module:model/GCPConnector} The populated <code>GCPConnector</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('serviceAccount')) {
        obj['serviceAccount'] = ApiClient.convertToType(data['serviceAccount'], 'String');
      }
      if (data.hasOwnProperty('ownerProjectID')) {
        obj['ownerProjectID'] = ApiClient.convertToType(data['ownerProjectID'], 'String');
      }
      if (data.hasOwnProperty('privateKeyID')) {
        obj['privateKeyID'] = ApiClient.convertToType(data['privateKeyID'], 'String');
      }
      if (data.hasOwnProperty('clientEmail')) {
        obj['clientEmail'] = ApiClient.convertToType(data['clientEmail'], 'String');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Display name of the connector. Searchable as String.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Service account of the connector, base64-encoded.
   * @member {String} serviceAccount
   */
  exports.prototype['serviceAccount'] = undefined;
  /**
   * The project ID which owns the service account. Searchable as String.
   * @member {String} ownerProjectID
   */
  exports.prototype['ownerProjectID'] = undefined;
  /**
   * Private key ID of the GCP service account. Searchable as String.
   * @member {String} privateKeyID
   */
  exports.prototype['privateKeyID'] = undefined;
  /**
   * Client email of the GCP service account. Searchable as String.
   * @member {String} clientEmail
   */
  exports.prototype['clientEmail'] = undefined;
  /**
   * ID of the connector.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;



  return exports;
}));



