/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ComputerModuleStatus'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ComputerModuleStatus'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.IntegrityMonitoringComputerExtension = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.ComputerModuleStatus);
  }
}(this, function(ApiClient, ComputerModuleStatus) {
  'use strict';




  /**
   * The IntegrityMonitoringComputerExtension model module.
   * @module model/IntegrityMonitoringComputerExtension
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>IntegrityMonitoringComputerExtension</code>.
   * Computer-level configuration for the Integrity Monitoring module. Null for tenants for whom Integrity Monitoring is hidden.
   * @alias module:model/IntegrityMonitoringComputerExtension
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>IntegrityMonitoringComputerExtension</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/IntegrityMonitoringComputerExtension} obj Optional instance to populate.
   * @return {module:model/IntegrityMonitoringComputerExtension} The populated <code>IntegrityMonitoringComputerExtension</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('moduleStatus')) {
        obj['moduleStatus'] = ComputerModuleStatus.constructFromObject(data['moduleStatus']);
      }
      if (data.hasOwnProperty('lastIntegrityScan')) {
        obj['lastIntegrityScan'] = ApiClient.convertToType(data['lastIntegrityScan'], 'Number');
      }
      if (data.hasOwnProperty('lastBaselineCreated')) {
        obj['lastBaselineCreated'] = ApiClient.convertToType(data['lastBaselineCreated'], 'Number');
      }
      if (data.hasOwnProperty('ruleIDs')) {
        obj['ruleIDs'] = ApiClient.convertToType(data['ruleIDs'], ['Number']);
      }
    }
    return obj;
  }

  /**
   * Module state. The 'inherited' value is write-only.
   * @member {module:model/IntegrityMonitoringComputerExtension.StateEnum} state
   */
  exports.prototype['state'] = undefined;
  /**
   * @member {module:model/ComputerModuleStatus} moduleStatus
   */
  exports.prototype['moduleStatus'] = undefined;
  /**
   * Timestamp of the last full scan for integrity, in milliseconds since epoch.
   * @member {Number} lastIntegrityScan
   */
  exports.prototype['lastIntegrityScan'] = undefined;
  /**
   * Timestamp of the last integrity baseline, in milliseconds since epoch.
   * @member {Number} lastBaselineCreated
   */
  exports.prototype['lastBaselineCreated'] = undefined;
  /**
   * IDs of the assigned Integrity Monitoring rules.
   * @member {Array.<Number>} ruleIDs
   */
  exports.prototype['ruleIDs'] = undefined;


  /**
   * Allowed values for the <code>state</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StateEnum = {
    /**
     * value: "inherited"
     * @const
     */
    "inherited": "inherited",
    /**
     * value: "real-time"
     * @const
     */
    "real-time": "real-time",
    /**
     * value: "on"
     * @const
     */
    "on": "on",
    /**
     * value: "off"
     * @const
     */
    "off": "off"  };


  return exports;
}));



