/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.NSXManagerInfo = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The NSXManagerInfo model module.
   * @module model/NSXManagerInfo
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>NSXManagerInfo</code>.
   * @alias module:model/NSXManagerInfo
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>NSXManagerInfo</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/NSXManagerInfo} obj Optional instance to populate.
   * @return {module:model/NSXManagerInfo} The populated <code>NSXManagerInfo</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('host')) {
        obj['host'] = ApiClient.convertToType(data['host'], 'String');
      }
      if (data.hasOwnProperty('port')) {
        obj['port'] = ApiClient.convertToType(data['port'], 'Number');
      }
      if (data.hasOwnProperty('username')) {
        obj['username'] = ApiClient.convertToType(data['username'], 'String');
      }
      if (data.hasOwnProperty('password')) {
        obj['password'] = ApiClient.convertToType(data['password'], 'String');
      }
      if (data.hasOwnProperty('webserverUrl')) {
        obj['webserverUrl'] = ApiClient.convertToType(data['webserverUrl'], 'String');
      }
      if (data.hasOwnProperty('nsxPolicySync')) {
        obj['nsxPolicySync'] = ApiClient.convertToType(data['nsxPolicySync'], 'Boolean');
      }
      if (data.hasOwnProperty('createDefaultEBT')) {
        obj['createDefaultEBT'] = ApiClient.convertToType(data['createDefaultEBT'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * NSX Manager IP address or hostname.
   * @member {String} host
   */
  exports.prototype['host'] = undefined;
  /**
   * NSX Manager port.
   * @member {Number} port
   */
  exports.prototype['port'] = undefined;
  /**
   * Username that the connector will use to authenticate to NSX Manager.
   * @member {String} username
   */
  exports.prototype['username'] = undefined;
  /**
   * Password of the NSX Manager user. Must be base64-encoded.
   * @member {String} password
   */
  exports.prototype['password'] = undefined;
  /**
   * URL to the appliance OVF file.
   * @member {String} webserverUrl
   */
  exports.prototype['webserverUrl'] = undefined;
  /**
   * Enable or disable the NSX policy sync feature.
   * @member {Boolean} nsxPolicySync
   */
  exports.prototype['nsxPolicySync'] = undefined;
  /**
   * Create the default event-based task (also called the 'default EBT').
   * @member {Boolean} createDefaultEBT
   */
  exports.prototype['createDefaultEBT'] = undefined;



  return exports;
}));



