/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/PolicyMapping'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./PolicyMapping'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.PolicyMigrationTask = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.PolicyMapping);
  }
}(this, function(ApiClient, PolicyMapping) {
  'use strict';




  /**
   * The PolicyMigrationTask model module.
   * @module model/PolicyMigrationTask
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>PolicyMigrationTask</code>.
   * Task to migrate policies
   * @alias module:model/PolicyMigrationTask
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>PolicyMigrationTask</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PolicyMigrationTask} obj Optional instance to populate.
   * @return {module:model/PolicyMigrationTask} The populated <code>PolicyMigrationTask</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('taskGUID')) {
        obj['taskGUID'] = ApiClient.convertToType(data['taskGUID'], 'String');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('created')) {
        obj['created'] = ApiClient.convertToType(data['created'], 'Number');
      }
      if (data.hasOwnProperty('lastUpdated')) {
        obj['lastUpdated'] = ApiClient.convertToType(data['lastUpdated'], 'Number');
      }
      if (data.hasOwnProperty('policyMappings')) {
        obj['policyMappings'] = ApiClient.convertToType(data['policyMappings'], [PolicyMapping]);
      }
      if (data.hasOwnProperty('errorCode')) {
        obj['errorCode'] = ApiClient.convertToType(data['errorCode'], 'Number');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Task GUID on Workload Security. Searchable as String.
   * @member {String} taskGUID
   */
  exports.prototype['taskGUID'] = undefined;
  /**
   * The migration status.
   * @member {module:model/PolicyMigrationTask.StatusEnum} status
   */
  exports.prototype['status'] = undefined;
  /**
   * Timestamp when the PolicyMigrationTask was created, in milliseconds since epoch. Searchable as Date.
   * @member {Number} created
   */
  exports.prototype['created'] = undefined;
  /**
   * Timestamp when the PolicyMigrationTask was updated, in milliseconds since epoch. Searchable as Date.
   * @member {Number} lastUpdated
   */
  exports.prototype['lastUpdated'] = undefined;
  /**
   * The mapping table of policies on this Deep Security Manager and the Workload Security.
   * @member {Array.<module:model/PolicyMapping>} policyMappings
   */
  exports.prototype['policyMappings'] = undefined;
  /**
   * The error code of the failed task.
   * @member {Number} errorCode
   */
  exports.prototype['errorCode'] = undefined;
  /**
   * ID of the policy migration task.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;


  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "requested"
     * @const
     */
    "requested": "requested",
    /**
     * value: "in-progress"
     * @const
     */
    "in-progress": "in-progress",
    /**
     * value: "complete"
     * @const
     */
    "complete": "complete",
    /**
     * value: "failed"
     * @const
     */
    "failed": "failed"  };


  return exports;
}));



