/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.Proxy = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Proxy model module.
   * @module model/Proxy
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>Proxy</code>.
   * Details of a proxy.
   * @alias module:model/Proxy
   * @class
   * @param name {String} Name of the proxy. The maximum length is 254 characters. Searchable as String.
   * @param hostName {String} Host name of the proxy. The maximum length is 254 characters. Searchable as String.
   * @param port {Number} Port of the proxy.
   */
  var exports = function(name, hostName, port) {
    var _this = this;

    _this['name'] = name;

    _this['hostName'] = hostName;
    _this['port'] = port;







  };

  /**
   * Constructs a <code>Proxy</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Proxy} obj Optional instance to populate.
   * @return {module:model/Proxy} The populated <code>Proxy</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('hostName')) {
        obj['hostName'] = ApiClient.convertToType(data['hostName'], 'String');
      }
      if (data.hasOwnProperty('port')) {
        obj['port'] = ApiClient.convertToType(data['port'], 'Number');
      }
      if (data.hasOwnProperty('protocol')) {
        obj['protocol'] = ApiClient.convertToType(data['protocol'], 'String');
      }
      if (data.hasOwnProperty('authenticated')) {
        obj['authenticated'] = ApiClient.convertToType(data['authenticated'], 'Boolean');
      }
      if (data.hasOwnProperty('username')) {
        obj['username'] = ApiClient.convertToType(data['username'], 'String');
      }
      if (data.hasOwnProperty('password')) {
        obj['password'] = ApiClient.convertToType(data['password'], 'String');
      }
      if (data.hasOwnProperty('proxyType')) {
        obj['proxyType'] = ApiClient.convertToType(data['proxyType'], 'String');
      }
      if (data.hasOwnProperty('sgproxy')) {
        obj['sgproxy'] = ApiClient.convertToType(data['sgproxy'], 'Boolean');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Name of the proxy. The maximum length is 254 characters. Searchable as String.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Description of the proxy. The maximum length is 2000 characters. Searchable as String.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Host name of the proxy. The maximum length is 254 characters. Searchable as String.
   * @member {String} hostName
   */
  exports.prototype['hostName'] = undefined;
  /**
   * Port of the proxy.
   * @member {Number} port
   */
  exports.prototype['port'] = undefined;
  /**
   * Protocol of the proxy. Default is \"http\".
   * @member {module:model/Proxy.ProtocolEnum} protocol
   */
  exports.prototype['protocol'] = undefined;
  /**
   * Flag indicating whether access to the proxy is authenticated. Default is \"false\".
   * @member {Boolean} authenticated
   */
  exports.prototype['authenticated'] = undefined;
  /**
   * Username of the proxy. The maximum length is 254 characters.
   * @member {String} username
   */
  exports.prototype['username'] = undefined;
  /**
   * Password of the proxy, write only. The maximum length is 254 characters.
   * @member {String} password
   */
  exports.prototype['password'] = undefined;
  /**
   * Type of proxy. support: 'userAssignedProxy', 'serviceGatewayProxy'
   * @member {String} proxyType
   */
  exports.prototype['proxyType'] = undefined;
  /**
   * @member {Boolean} sgproxy
   */
  exports.prototype['sgproxy'] = undefined;
  /**
   * ID of the proxy. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;


  /**
   * Allowed values for the <code>protocol</code> property.
   * @enum {String}
   * @readonly
   */
  exports.ProtocolEnum = {
    /**
     * value: "http"
     * @const
     */
    "http": "http",
    /**
     * value: "socks4"
     * @const
     */
    "socks4": "socks4",
    /**
     * value: "socks5"
     * @const
     */
    "socks5": "socks5"  };


  return exports;
}));



