/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.RulesetRights = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The RulesetRights model module.
   * @module model/RulesetRights
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>RulesetRights</code>.
   * Ruleset right details.
   * @alias module:model/RulesetRights
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>RulesetRights</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RulesetRights} obj Optional instance to populate.
   * @return {module:model/RulesetRights} The populated <code>RulesetRights</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('canCreateNewRulesets')) {
        obj['canCreateNewRulesets'] = ApiClient.convertToType(data['canCreateNewRulesets'], 'Boolean');
      }
      if (data.hasOwnProperty('canDeleteRulesets')) {
        obj['canDeleteRulesets'] = ApiClient.convertToType(data['canDeleteRulesets'], 'Boolean');
      }
      if (data.hasOwnProperty('canEditRulesetProperties')) {
        obj['canEditRulesetProperties'] = ApiClient.convertToType(data['canEditRulesetProperties'], 'Boolean');
      }
      if (data.hasOwnProperty('canViewRulesets')) {
        obj['canViewRulesets'] = ApiClient.convertToType(data['canViewRulesets'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Right to create new rulesets.
   * @member {Boolean} canCreateNewRulesets
   */
  exports.prototype['canCreateNewRulesets'] = undefined;
  /**
   * Right to delete rulesets.
   * @member {Boolean} canDeleteRulesets
   */
  exports.prototype['canDeleteRulesets'] = undefined;
  /**
   * Right to edit ruleset properties.
   * @member {Boolean} canEditRulesetProperties
   */
  exports.prototype['canEditRulesetProperties'] = undefined;
  /**
   * Right to view rulesets.
   * @member {Boolean} canViewRulesets
   */
  exports.prototype['canViewRulesets'] = undefined;



  return exports;
}));



