/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SmartFolderRuleGroup', 'model/TagFolder'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./SmartFolderRuleGroup'), require('./TagFolder'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.SmartFolder = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.SmartFolderRuleGroup, root.Deepsecurity.TagFolder);
  }
}(this, function(ApiClient, SmartFolderRuleGroup, TagFolder) {
  'use strict';




  /**
   * The SmartFolder model module.
   * @module model/SmartFolder
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>SmartFolder</code>.
   * Details of a smart folder.
   * @alias module:model/SmartFolder
   * @class
   * @param name {String} Name of the smart folder. The maximum length is 255 characters. Searchable as String.
   */
  var exports = function(name) {
    var _this = this;

    _this['name'] = name;







  };

  /**
   * Constructs a <code>SmartFolder</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SmartFolder} obj Optional instance to populate.
   * @return {module:model/SmartFolder} The populated <code>SmartFolder</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('parentSmartFolderID')) {
        obj['parentSmartFolderID'] = ApiClient.convertToType(data['parentSmartFolderID'], 'Number');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('ruleGroups')) {
        obj['ruleGroups'] = ApiClient.convertToType(data['ruleGroups'], [SmartFolderRuleGroup]);
      }
      if (data.hasOwnProperty('tagFolder')) {
        obj['tagFolder'] = TagFolder.constructFromObject(data['tagFolder']);
      }
      if (data.hasOwnProperty('logicalOperator')) {
        obj['logicalOperator'] = ApiClient.convertToType(data['logicalOperator'], 'String');
      }
      if (data.hasOwnProperty('duplicateOf')) {
        obj['duplicateOf'] = ApiClient.convertToType(data['duplicateOf'], 'Number');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Name of the smart folder. The maximum length is 255 characters. Searchable as String.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * ID of the parent smart folder. Searchable as Numeric.
   * @member {Number} parentSmartFolderID
   */
  exports.prototype['parentSmartFolderID'] = undefined;
  /**
   * Type of the smart folder.
   * @member {module:model/SmartFolder.TypeEnum} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Rule groups of the smart folder.
   * @member {Array.<module:model/SmartFolderRuleGroup>} ruleGroups
   */
  exports.prototype['ruleGroups'] = undefined;
  /**
   * AWS/GCP/Azure tag folder.
   * @member {module:model/TagFolder} tagFolder
   */
  exports.prototype['tagFolder'] = undefined;
  /**
   * Comparison of the smart folder.
   * @member {module:model/SmartFolder.LogicalOperatorEnum} logicalOperator
   */
  exports.prototype['logicalOperator'] = undefined;
  /**
   * The ID of the Smart Folder to duplicate. If this value is set, then all other parameters will be ignored.
   * @member {Number} duplicateOf
   */
  exports.prototype['duplicateOf'] = undefined;
  /**
   * ID of the smart folder. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;


  /**
   * Allowed values for the <code>type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TypeEnum = {
    /**
     * value: "standard"
     * @const
     */
    "standard": "standard",
    /**
     * value: "hierarchical-tag-root"
     * @const
     */
    "hierarchical-tag-root": "hierarchical-tag-root",
    /**
     * value: "hierarchical-tag-child"
     * @const
     */
    "hierarchical-tag-child": "hierarchical-tag-child",
    /**
     * value: "independent-child"
     * @const
     */
    "independent-child": "independent-child"  };

  /**
   * Allowed values for the <code>logicalOperator</code> property.
   * @enum {String}
   * @readonly
   */
  exports.LogicalOperatorEnum = {
    /**
     * value: "and"
     * @const
     */
    "and": "and",
    /**
     * value: "or"
     * @const
     */
    "or": "or"  };


  return exports;
}));



