/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.SmartFolderRule = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The SmartFolderRule model module.
   * @module model/SmartFolderRule
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>SmartFolderRule</code>.
   * Details of rule for rule group in smart folder.
   * @alias module:model/SmartFolderRule
   * @class
   */
  var exports = function() {
    var _this = this;







  };

  /**
   * Constructs a <code>SmartFolderRule</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SmartFolderRule} obj Optional instance to populate.
   * @return {module:model/SmartFolderRule} The populated <code>SmartFolderRule</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('key')) {
        obj['key'] = ApiClient.convertToType(data['key'], 'String');
      }
      if (data.hasOwnProperty('comparisonOperator')) {
        obj['comparisonOperator'] = ApiClient.convertToType(data['comparisonOperator'], 'String');
      }
      if (data.hasOwnProperty('value')) {
        obj['value'] = ApiClient.convertToType(data['value'], 'String');
      }
      if (data.hasOwnProperty('secondaryComparisonOperator')) {
        obj['secondaryComparisonOperator'] = ApiClient.convertToType(data['secondaryComparisonOperator'], 'String');
      }
      if (data.hasOwnProperty('secondaryValue')) {
        obj['secondaryValue'] = ApiClient.convertToType(data['secondaryValue'], 'String');
      }
      if (data.hasOwnProperty('timeUnit')) {
        obj['timeUnit'] = ApiClient.convertToType(data['timeUnit'], 'String');
      }
    }
    return obj;
  }

  /**
   * The key that specifies the type of rule.
   * @member {module:model/SmartFolderRule.KeyEnum} key
   */
  exports.prototype['key'] = undefined;
  /**
   * The operator of the rule.
   * @member {module:model/SmartFolderRule.ComparisonOperatorEnum} comparisonOperator
   */
  exports.prototype['comparisonOperator'] = undefined;
  /**
   * The value of the rule.<br>• The value for <code>general-agent-activated</code>/<code>general-agent-offline</code>/<code>general-crio-host</code>/<code>general-docker-host</code> would be <code>yes</code>/<code>no</code>.<br>• The value for <code>general-computer-type</code> would be <code>physical-computer</code>/<code>amazon-ec2-instance</code>/<code>aws-workspace</code>/<code>vcloud-virtual-machine</code>/<code>azure-instance</code>/<code>azure-arm-instance</code>/<code>gcp-compute-instance</code>.<br>• The value for <code>general-policy</code> would be policy ID.
   * @member {String} value
   */
  exports.prototype['value'] = undefined;
  /**
   * The secondary operator of the rule if needed.
   * @member {module:model/SmartFolderRule.SecondaryComparisonOperatorEnum} secondaryComparisonOperator
   */
  exports.prototype['secondaryComparisonOperator'] = undefined;
  /**
   * The secondary value of the rule if needed.
   * @member {String} secondaryValue
   */
  exports.prototype['secondaryValue'] = undefined;
  /**
   * The time unit of the rule if the key is <code>general-last-recommendation-scan-time</code>/<code>general-last-agent-communication</code>.
   * @member {module:model/SmartFolderRule.TimeUnitEnum} timeUnit
   */
  exports.prototype['timeUnit'] = undefined;


  /**
   * Allowed values for the <code>key</code> property.
   * @enum {String}
   * @readonly
   */
  exports.KeyEnum = {
    /**
     * value: "general-host-name"
     * @const
     */
    "general-host-name": "general-host-name",
    /**
     * value: "general-display-name"
     * @const
     */
    "general-display-name": "general-display-name",
    /**
     * value: "general-description"
     * @const
     */
    "general-description": "general-description",
    /**
     * value: "general-computer-group"
     * @const
     */
    "general-computer-group": "general-computer-group",
    /**
     * value: "general-os"
     * @const
     */
    "general-os": "general-os",
    /**
     * value: "general-ip"
     * @const
     */
    "general-ip": "general-ip",
    /**
     * value: "general-policy"
     * @const
     */
    "general-policy": "general-policy",
    /**
     * value: "general-agent-activated"
     * @const
     */
    "general-agent-activated": "general-agent-activated",
    /**
     * value: "general-docker-host"
     * @const
     */
    "general-docker-host": "general-docker-host",
    /**
     * value: "general-crio-host"
     * @const
     */
    "general-crio-host": "general-crio-host",
    /**
     * value: "general-computer-type"
     * @const
     */
    "general-computer-type": "general-computer-type",
    /**
     * value: "general-last-recommendation-scan-time"
     * @const
     */
    "general-last-recommendation-scan-time": "general-last-recommendation-scan-time",
    /**
     * value: "general-last-agent-communication"
     * @const
     */
    "general-last-agent-communication": "general-last-agent-communication",
    /**
     * value: "general-agent-offline"
     * @const
     */
    "general-agent-offline": "general-agent-offline",
    /**
     * value: "general-host-created-time"
     * @const
     */
    "general-host-created-time": "general-host-created-time",
    /**
     * value: "general-host-tasks"
     * @const
     */
    "general-host-tasks": "general-host-tasks",
    /**
     * value: "general-agent-version"
     * @const
     */
    "general-agent-version": "general-agent-version",
    /**
     * value: "aws-tag"
     * @const
     */
    "aws-tag": "aws-tag",
    /**
     * value: "aws-security-group-name"
     * @const
     */
    "aws-security-group-name": "aws-security-group-name",
    /**
     * value: "aws-security-group-id"
     * @const
     */
    "aws-security-group-id": "aws-security-group-id",
    /**
     * value: "aws-ami-id"
     * @const
     */
    "aws-ami-id": "aws-ami-id",
    /**
     * value: "aws-account-id"
     * @const
     */
    "aws-account-id": "aws-account-id",
    /**
     * value: "aws-account-name"
     * @const
     */
    "aws-account-name": "aws-account-name",
    /**
     * value: "aws-region-id"
     * @const
     */
    "aws-region-id": "aws-region-id",
    /**
     * value: "aws-region-name"
     * @const
     */
    "aws-region-name": "aws-region-name",
    /**
     * value: "aws-vpc-id"
     * @const
     */
    "aws-vpc-id": "aws-vpc-id",
    /**
     * value: "aws-subnet-id"
     * @const
     */
    "aws-subnet-id": "aws-subnet-id",
    /**
     * value: "aws-directory-id"
     * @const
     */
    "aws-directory-id": "aws-directory-id",
    /**
     * value: "azure-subscription-name"
     * @const
     */
    "azure-subscription-name": "azure-subscription-name",
    /**
     * value: "azure-resource-group"
     * @const
     */
    "azure-resource-group": "azure-resource-group",
    /**
     * value: "azure-location"
     * @const
     */
    "azure-location": "azure-location",
    /**
     * value: "azure-tag"
     * @const
     */
    "azure-tag": "azure-tag",
    /**
     * value: "gcp-label"
     * @const
     */
    "gcp-label": "gcp-label",
    /**
     * value: "gcp-network-tag"
     * @const
     */
    "gcp-network-tag": "gcp-network-tag",
    /**
     * value: "vcenter-name"
     * @const
     */
    "vcenter-name": "vcenter-name",
    /**
     * value: "vcenter-datacenter"
     * @const
     */
    "vcenter-datacenter": "vcenter-datacenter",
    /**
     * value: "vcenter-folder"
     * @const
     */
    "vcenter-folder": "vcenter-folder",
    /**
     * value: "vcenter-esx-hostname"
     * @const
     */
    "vcenter-esx-hostname": "vcenter-esx-hostname",
    /**
     * value: "vcenter-custom-attribute"
     * @const
     */
    "vcenter-custom-attribute": "vcenter-custom-attribute",
    /**
     * value: "vcenter-power-state"
     * @const
     */
    "vcenter-power-state": "vcenter-power-state",
    /**
     * value: "vcloud-name"
     * @const
     */
    "vcloud-name": "vcloud-name",
    /**
     * value: "vcloud-datacenter"
     * @const
     */
    "vcloud-datacenter": "vcloud-datacenter",
    /**
     * value: "vcloud-vapp"
     * @const
     */
    "vcloud-vapp": "vcloud-vapp",
    /**
     * value: "directory-name"
     * @const
     */
    "directory-name": "directory-name",
    /**
     * value: "directory-folder"
     * @const
     */
    "directory-folder": "directory-folder"  };

  /**
   * Allowed values for the <code>comparisonOperator</code> property.
   * @enum {String}
   * @readonly
   */
  exports.ComparisonOperatorEnum = {
    /**
     * value: "equals"
     * @const
     */
    "equals": "equals",
    /**
     * value: "not-equals"
     * @const
     */
    "not-equals": "not-equals",
    /**
     * value: "contains"
     * @const
     */
    "contains": "contains",
    /**
     * value: "does-not-contain"
     * @const
     */
    "does-not-contain": "does-not-contain",
    /**
     * value: "any-value"
     * @const
     */
    "any-value": "any-value",
    /**
     * value: "in-range"
     * @const
     */
    "in-range": "in-range",
    /**
     * value: "not-in-range"
     * @const
     */
    "not-in-range": "not-in-range",
    /**
     * value: "older-than"
     * @const
     */
    "older-than": "older-than",
    /**
     * value: "more-recently-than"
     * @const
     */
    "more-recently-than": "more-recently-than",
    /**
     * value: "never"
     * @const
     */
    "never": "never",
    /**
     * value: "before"
     * @const
     */
    "before": "before",
    /**
     * value: "after"
     * @const
     */
    "after": "after",
    /**
     * value: "version-older-than"
     * @const
     */
    "version-older-than": "version-older-than",
    /**
     * value: "version-older-than-or-equal-to"
     * @const
     */
    "version-older-than-or-equal-to": "version-older-than-or-equal-to",
    /**
     * value: "version-newer-than"
     * @const
     */
    "version-newer-than": "version-newer-than",
    /**
     * value: "version-newer-than-or-equal-to"
     * @const
     */
    "version-newer-than-or-equal-to": "version-newer-than-or-equal-to"  };

  /**
   * Allowed values for the <code>secondaryComparisonOperator</code> property.
   * @enum {String}
   * @readonly
   */
  exports.SecondaryComparisonOperatorEnum = {
    /**
     * value: "equals"
     * @const
     */
    "equals": "equals",
    /**
     * value: "not-equals"
     * @const
     */
    "not-equals": "not-equals",
    /**
     * value: "contains"
     * @const
     */
    "contains": "contains",
    /**
     * value: "does-not-contain"
     * @const
     */
    "does-not-contain": "does-not-contain",
    /**
     * value: "any-value"
     * @const
     */
    "any-value": "any-value",
    /**
     * value: "in-range"
     * @const
     */
    "in-range": "in-range",
    /**
     * value: "not-in-range"
     * @const
     */
    "not-in-range": "not-in-range",
    /**
     * value: "older-than"
     * @const
     */
    "older-than": "older-than",
    /**
     * value: "more-recently-than"
     * @const
     */
    "more-recently-than": "more-recently-than",
    /**
     * value: "never"
     * @const
     */
    "never": "never",
    /**
     * value: "before"
     * @const
     */
    "before": "before",
    /**
     * value: "after"
     * @const
     */
    "after": "after",
    /**
     * value: "version-older-than"
     * @const
     */
    "version-older-than": "version-older-than",
    /**
     * value: "version-older-than-or-equal-to"
     * @const
     */
    "version-older-than-or-equal-to": "version-older-than-or-equal-to",
    /**
     * value: "version-newer-than"
     * @const
     */
    "version-newer-than": "version-newer-than",
    /**
     * value: "version-newer-than-or-equal-to"
     * @const
     */
    "version-newer-than-or-equal-to": "version-newer-than-or-equal-to"  };

  /**
   * Allowed values for the <code>timeUnit</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TimeUnitEnum = {
    /**
     * value: "minutes"
     * @const
     */
    "minutes": "minutes",
    /**
     * value: "hours"
     * @const
     */
    "hours": "hours",
    /**
     * value: "days"
     * @const
     */
    "days": "days",
    /**
     * value: "weeks"
     * @const
     */
    "weeks": "weeks"  };


  return exports;
}));



