/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.TimeRange = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The TimeRange model module.
   * @module model/TimeRange
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>TimeRange</code>.
   * Details for a time range. A time range identifies the period of time for which a report is generated via a scheduled task.
   * @alias module:model/TimeRange
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>TimeRange</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TimeRange} obj Optional instance to populate.
   * @return {module:model/TimeRange} The populated <code>TimeRange</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('units')) {
        obj['units'] = ApiClient.convertToType(data['units'], 'String');
      }
      if (data.hasOwnProperty('value')) {
        obj['value'] = ApiClient.convertToType(data['value'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Units for the time range
   * @member {module:model/TimeRange.UnitsEnum} units
   */
  exports.prototype['units'] = undefined;
  /**
   * Value of the time range. With the units, defines the report's time range as the length of time previous to the current time.
   * @member {Number} value
   */
  exports.prototype['value'] = undefined;


  /**
   * Allowed values for the <code>units</code> property.
   * @enum {String}
   * @readonly
   */
  exports.UnitsEnum = {
    /**
     * value: "hour"
     * @const
     */
    "hour": "hour",
    /**
     * value: "day"
     * @const
     */
    "day": "day",
    /**
     * value: "week"
     * @const
     */
    "week": "week",
    /**
     * value: "month"
     * @const
     */
    "month": "month"  };


  return exports;
}));



