/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.TrustRuleset = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The TrustRuleset model module.
   * @module model/TrustRuleset
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>TrustRuleset</code>.
   * @alias module:model/TrustRuleset
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>TrustRuleset</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TrustRuleset} obj Optional instance to populate.
   * @return {module:model/TrustRuleset} The populated <code>TrustRuleset</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('version')) {
        obj['version'] = ApiClient.convertToType(data['version'], 'Number');
      }
      if (data.hasOwnProperty('createdTime')) {
        obj['createdTime'] = ApiClient.convertToType(data['createdTime'], 'Number');
      }
      if (data.hasOwnProperty('lastUpdatedTime')) {
        obj['lastUpdatedTime'] = ApiClient.convertToType(data['lastUpdatedTime'], 'Number');
      }
      if (data.hasOwnProperty('usageCount')) {
        obj['usageCount'] = ApiClient.convertToType(data['usageCount'], 'Number');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Name of the trust ruleset. Searchable as String.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Description of the trust ruleset. Searchable as String.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Version number of the trust ruleset. Incremented by one whenever the ruleset rules are modified. Searchable as Numeric.
   * @member {Number} version
   */
  exports.prototype['version'] = undefined;
  /**
   * Timestamp of the trust ruleset's creation, in milliseconds since epoch. Searchable as Date.
   * @member {Number} createdTime
   */
  exports.prototype['createdTime'] = undefined;
  /**
   * Timestamp of when the trust ruleset was last updated, in milliseconds since epoch. Searchable as Date.
   * @member {Number} lastUpdatedTime
   */
  exports.prototype['lastUpdatedTime'] = undefined;
  /**
   * Count for trust ruleset usage.
   * @member {Number} usageCount
   */
  exports.prototype['usageCount'] = undefined;
  /**
   * ID of the trust ruleset. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;



  return exports;
}));



