/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/NSXManagerInfo', 'model/VCenterInfo'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./NSXManagerInfo'), require('./VCenterInfo'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.VCenterConnector = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.NSXManagerInfo, root.Deepsecurity.VCenterInfo);
  }
}(this, function(ApiClient, NSXManagerInfo, VCenterInfo) {
  'use strict';




  /**
   * The VCenterConnector model module.
   * @module model/VCenterConnector
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>VCenterConnector</code>.
   * Everything about VCenter connector.
   * @alias module:model/VCenterConnector
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>VCenterConnector</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/VCenterConnector} obj Optional instance to populate.
   * @return {module:model/VCenterConnector} The populated <code>VCenterConnector</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('autoTrustCertificate')) {
        obj['autoTrustCertificate'] = ApiClient.convertToType(data['autoTrustCertificate'], 'Boolean');
      }
      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'Number');
      }
      if (data.hasOwnProperty('vCenter')) {
        obj['vCenter'] = VCenterInfo.constructFromObject(data['vCenter']);
      }
      if (data.hasOwnProperty('NSXManager')) {
        obj['NSXManager'] = NSXManagerInfo.constructFromObject(data['NSXManager']);
      }
    }
    return obj;
  }

  /**
   * Automatically trust detected certificate when trying to connect to vCenter connector or NSX Manager
   * @member {Boolean} autoTrustCertificate
   */
  exports.prototype['autoTrustCertificate'] = undefined;
  /**
   * ID number of the vCenter connector.
   * @member {Number} id
   */
  exports.prototype['id'] = undefined;
  /**
   * vCenter settings.
   * @member {module:model/VCenterInfo} vCenter
   */
  exports.prototype['vCenter'] = undefined;
  /**
   * @member {module:model/NSXManagerInfo} NSXManager
   */
  exports.prototype['NSXManager'] = undefined;



  return exports;
}));



