/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.WorkloadSecurityLink = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The WorkloadSecurityLink model module.
   * @module model/WorkloadSecurityLink
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>WorkloadSecurityLink</code>.
   * Workload security link details.
   * @alias module:model/WorkloadSecurityLink
   * @class
   */
  var exports = function() {
    var _this = this;







  };

  /**
   * Constructs a <code>WorkloadSecurityLink</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/WorkloadSecurityLink} obj Optional instance to populate.
   * @return {module:model/WorkloadSecurityLink} The populated <code>WorkloadSecurityLink</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('workloadSecurityTenantGUID')) {
        obj['workloadSecurityTenantGUID'] = ApiClient.convertToType(data['workloadSecurityTenantGUID'], 'String');
      }
      if (data.hasOwnProperty('workloadSecurityUrl')) {
        obj['workloadSecurityUrl'] = ApiClient.convertToType(data['workloadSecurityUrl'], 'String');
      }
      if (data.hasOwnProperty('workloadSecurityAPIKey')) {
        obj['workloadSecurityAPIKey'] = ApiClient.convertToType(data['workloadSecurityAPIKey'], 'String');
      }
      if (data.hasOwnProperty('cloudOneAPIKey')) {
        obj['cloudOneAPIKey'] = ApiClient.convertToType(data['cloudOneAPIKey'], 'String');
      }
      if (data.hasOwnProperty('workloadSecurityCA')) {
        obj['workloadSecurityCA'] = ApiClient.convertToType(data['workloadSecurityCA'], 'String');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Tenant GUID on Workload Security.
   * @member {String} workloadSecurityTenantGUID
   */
  exports.prototype['workloadSecurityTenantGUID'] = undefined;
  /**
   * URL of Workload Security.
   * @member {String} workloadSecurityUrl
   */
  exports.prototype['workloadSecurityUrl'] = undefined;
  /**
   * API key of Workload Security. Cannot be given together with cloudOneAPIKey.
   * @member {String} workloadSecurityAPIKey
   */
  exports.prototype['workloadSecurityAPIKey'] = undefined;
  /**
   * API key of Cloud One. Cannot be given together with workloadSecurityAPIKey.
   * @member {String} cloudOneAPIKey
   */
  exports.prototype['cloudOneAPIKey'] = undefined;
  /**
   * Pinned public certificate for agents of Workload Security.
   * @member {String} workloadSecurityCA
   */
  exports.prototype['workloadSecurityCA'] = undefined;
  /**
   * ID of the Workload Security Link.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;



  return exports;
}));



