/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 20.0.904
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/PolicyModuleStatus'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./PolicyModuleStatus'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.AntiMalwarePolicyExtension = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.PolicyModuleStatus);
  }
}(this, function(ApiClient, PolicyModuleStatus) {
  'use strict';




  /**
   * The AntiMalwarePolicyExtension model module.
   * @module model/AntiMalwarePolicyExtension
   * @version 20.0.904
   */

  /**
   * Constructs a new <code>AntiMalwarePolicyExtension</code>.
   * Policy-level configuration for the Anti-Malware module
   * @alias module:model/AntiMalwarePolicyExtension
   * @class
   */
  var exports = function() {
    var _this = this;







  };

  /**
   * Constructs a <code>AntiMalwarePolicyExtension</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AntiMalwarePolicyExtension} obj Optional instance to populate.
   * @return {module:model/AntiMalwarePolicyExtension} The populated <code>AntiMalwarePolicyExtension</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('moduleStatus')) {
        obj['moduleStatus'] = PolicyModuleStatus.constructFromObject(data['moduleStatus']);
      }
      if (data.hasOwnProperty('realTimeScanConfigurationID')) {
        obj['realTimeScanConfigurationID'] = ApiClient.convertToType(data['realTimeScanConfigurationID'], 'Number');
      }
      if (data.hasOwnProperty('realTimeScanScheduleID')) {
        obj['realTimeScanScheduleID'] = ApiClient.convertToType(data['realTimeScanScheduleID'], 'Number');
      }
      if (data.hasOwnProperty('manualScanConfigurationID')) {
        obj['manualScanConfigurationID'] = ApiClient.convertToType(data['manualScanConfigurationID'], 'Number');
      }
      if (data.hasOwnProperty('scheduledScanConfigurationID')) {
        obj['scheduledScanConfigurationID'] = ApiClient.convertToType(data['scheduledScanConfigurationID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Module state. The 'inherited' value is write-only.
   * @member {module:model/AntiMalwarePolicyExtension.StateEnum} state
   */
  exports.prototype['state'] = undefined;
  /**
   * @member {module:model/PolicyModuleStatus} moduleStatus
   */
  exports.prototype['moduleStatus'] = undefined;
  /**
   * ID of the Real Time Scan Configuration.
   * @member {Number} realTimeScanConfigurationID
   */
  exports.prototype['realTimeScanConfigurationID'] = undefined;
  /**
   * ID of the Real Time Schedule.
   * @member {Number} realTimeScanScheduleID
   */
  exports.prototype['realTimeScanScheduleID'] = undefined;
  /**
   * ID of the Manual Scan Configuration.
   * @member {Number} manualScanConfigurationID
   */
  exports.prototype['manualScanConfigurationID'] = undefined;
  /**
   * ID of the Scheduled Scan Configuration.
   * @member {Number} scheduledScanConfigurationID
   */
  exports.prototype['scheduledScanConfigurationID'] = undefined;


  /**
   * Allowed values for the <code>state</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StateEnum = {
    /**
     * value: "inherited"
     * @const
     */
    "inherited": "inherited",
    /**
     * value: "on"
     * @const
     */
    "on": "on",
    /**
     * value: "off"
     * @const
     */
    "off": "off"  };


  return exports;
}));



